/* $Id: etc.c,v 1.1 1996/11/07 08:03:32 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	Gp[`
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

#include <stdio.h>
#include <ctype.h>	/* isxdigit isdigit */
#include <stdlib.h>	/* exit */
#include <stdarg.h>
#include "estruct.h"
#include "global.h"
#include "etc.h"
#include "label.h"
#include "offset.h"
#include "symbol.h"

USEOPTION	option_q;

/* function in main.c */
extern void free_load_buffer( void );


extern ULONG	atox( char *p )
{
    ULONG	val = 0;
    
    while( isxdigit( *p )) {
	if( isdigit( *p ) )
	    val = val * 16 + *p - '0';
	else
	    val = val * 16 + tolower( *p ) - 'a' + 10 ;
	p++;
    }
    return val;
}


extern void	err( int code , char *fmt , ... )
{
    extern print_title();	/* main.c */
    va_list ap;

    print_title();
    va_start( ap , fmt );
    vfprintf( stderr , fmt , ap );
    va_end( ap );

    if( code ) {
	free_labelbuf();
	free_relocate_buffer();
	free_symbuf();
	free_load_buffer();
	exit( code );
    }
}


/*

  safe malloc

*/
extern void *Malloc( ULONG byte )
{
    void	*rc;

    if( byte == 0 )
	byte = 1;
    if( ( rc = malloc( byte ) ) == NULL ) {
	err( 1 , "q[vsĂ܂\n" );
    }
    return rc;
}


#ifndef	Mfree
/*

  safe mfree

  free()NULLnꍇ͉ɐÎŁA
  #define Mfree(ptr) free(ptr)
  ƂĂ܂.  

*/
extern void	Mfree( void *ptr )
{
    if( ptr != NULL )
	free( ptr );
}
#endif


/*

  safe realloc

*/
extern void	*Realloc( void *ptr , int size )
{
    void	*rc;
    
    if( ( rc = realloc( ptr , size ) ) == NULL )
	err( 1 , "q[vsĂ܂\n" );
    return rc ;
}


#ifndef	__LIBC__
extern int	eprintf( const char *fmt , ... )
{
    va_list ap;
    va_start( ap , fmt );
    vfprintf( stderr , fmt , ap );
    va_end( ap );
}
#endif

/* #define eputc( c ) fputc( c , stderr ) */
extern int	eputc( int c )
{
    return fputc( c , stderr );
}


#ifndef	__GNUC__
extern ULONG	min( ULONG a , ULONG b )
{
    return a < b ? a : b;
}


extern ULONG	max( ULONG a , ULONG b );
{
    return a > b ? a : b;
}
#endif


/* EOF */
