/* $Id: generate.c,v 1.1 1996/11/07 08:03:36 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	\[XR[hWFl[gW[
 *	Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *	All rights reserved.
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

#include <stdio.h>
#include <stdlib.h>	/* getenv */
#include <time.h>	/* time ctime */
#include <string.h>	/* strcmp */
#include <ctype.h>	/* tolower */
#ifdef	OSK
#include <kanji.h>	/* iskanji, etc. */
#endif	/* OSK */
#ifndef unix
#   ifdef MYU_HEADERS
#	include <jctype.h>	/* iskanji isprkana */
#   else
#	include <jfctype.h>
#   endif
#else
#   include <jctype.h>
#   include <io.h>	/* dtasc tmasc */
#endif

#include "estruct.h"
#include "global.h"
#include "hex.h"
#include "disasm.h"
#include "label.h"	/* search_label etc. */
#include "offset.h"	/* depend_address, nearadrs */
#include "symbol.h"	/* symbol_search */
#include "etc.h"	/* charout */
#include "include.h"	/* Doscall_mac_path , etc. */
#include "generate.h"
#include "output.h"
#include "table.h"


USEOPTION option_r , option_x , option_B , option_M , option_N , /* option_Q , */
	  option_S , option_U;


int SymbolColonNum = 2;

extern	char	CommentChar;
extern	short	MPU_type;
extern	short	FPCP_ID[16];

/* a7  sp Əo͂邩? */
short	sp_a7_flag;


/* static ֐vg^Cv */
private lblbuf		*gen( char* , address , lblbuf* );
private address		textgen( address , address );
private void		a7toSP( operand * );
INLINE private boolean	check_displacement( address , disasm* );
private address		datagen( address , address , opesize );
private void		datagen_sub( address , address , opesize );
private void		dataout( address , ULONG , opesize );
private void		byteout( address , ULONG , boolean );
private void		wordout( address , ULONG );
private void		longout( address , ULONG );
private void		strgen( address , address );
private void		relgen( address , address );
private void		rellonggen( address , address );
private void		byteout_for_moption( address , char* , int );
private void		zgen( address , address );
private address		tablegen( address , address , lblmode );
private address		tablegen_sub( struct _formula* , address , address , int );
private void		tablegen_label( address , address , lblbuf* );
private void		bssgen( address , address , opesize );
private void		label_line_out( address , lblmode );
private void		label_op_out( address );
private void		output_opecode( char* );
private void		makeheader( char* , time_t , int , char*[] );
#ifdef	OSKDIS
private void		vlabelout( address , boolean , lblmode );
#endif	OSKDIS

int Data_width = 8;		/* f[^̈̉oCg */
int String_width = 60;		/* ̈̉oCg */

size_mode Generate_SizeMode = SIZE_NORMAL;

char	Label_first_char = 'L';	/* x̐擪 */

#ifdef	OSKDIS
char	*OS9label[ 0x100 ];	/* os9	 F$???(I$???)	*/
char	*MATHlabel[ 0x100 ];	/* tcall T$Math,T$???	*/
char	*CIOlabel[ 0x100 ];	/* tcall CIO$Trap,C$??? */
#else
char	*IOCSlabel[ 0x100 ];
char	IOCSCallName[ 16 ] = "IOCS";
#endif	/* OSKDIS */
int Xtab = 7;			/* /x option TAB level */
int Atab = 8;			/* /a option TAB level */
int Mtab = 5;			/* /M option TAB level */

static char opsize[] = "bwlqssdxp";


#define SAME_CONST_COMPRESS_LENGTH  0x40	/* ȏȂ dcb.b ɂ */
#ifdef	OSKDIS
#define DC_B	"\tdc.b\t"
#define DC_W	"\tdc.w\t"
#define DC_L	"\tdc.l\t"
#define DS_B	"\tds.b\t"
#define DS_W	"\tds.w\t"
#define DS_L	"\tds.l\t"
#else
#define DC_B	"\t.dc.b\t"
#define DC_W	"\t.dc.w\t"
#define DC_L	"\t.dc.l\t"
#define DS_B	"\t.ds.b\t"
#define DS_W	"\t.ds.w\t"
#define DS_L	"\t.ds.l\t"
#endif	/* OSKDIS */

#ifndef	OSKDIS
#define DCB_B	"\t.dcb.b\t"
#define DCB_W	"\t.dcb.w\t"
#define DCB_L	"\t.dcb.l\t"
#endif	/* !OSKDIS */


INLINE static char  *strcpy2( char *dest , char *source )
{
    while( ( *dest++ = *source++ ) )
	;
    return --dest;
}


/*

  Check displacement of Relative branch

  return FALSE ;     short    ōς displacement  word ̏ꍇ
	́Ashort||word ōς displacement  long ̏ꍇ

*/
INLINE static boolean	check_displacement( address pc , disasm *code )
{
    long    dist = (ULONG)code->jmp - (ULONG)pc;

    if( tolower( code->opecode[0] ) == 'd' )	/* dbcc : always 16bit displacement */
	return( TRUE );

    if( code->size == LONGSIZE && dist <= 32767 && -dist <= 32768 + 2 )
	return( FALSE );
    if( code->size == WORDSIZE && dist <= 127 && -dist <= 128 + 2 )
	return( FALSE );
    if( code->size == SHORTSIZE && 126 <= dist )
	return( FALSE );
    return( TRUE );
}


/*

  AZu\[Xo͂

  input:
    xfilename	: execute file name
    sfilename	: output file name
    filedate	: execute file' time stamp
    argc	: same to argc given to main()
    argv	: same to argv given to main()

*/
extern void generate( char *xfilename , char *sfilename , time_t filedate
						, int argc , char *argv[] )
{
    address pc;
    lblbuf  *lptr;
    address nlabel;
    lblmode mode, nmode;
#ifdef	OSKDIS
    ULONG   *idatsiz;
#endif	/* OSKDIS */

    /* j[jbN͕Kv */
    Disasm_String = TRUE;

    if( option_x )
	Atab += 2;

    if( option_U )
	strupr( opsize );

    init_output();
    output_file_open( sfilename , 0 );

    makeheader( xfilename , filedate , argc , argv );

    lptr = next( BeginTEXT );
    pc = lptr->label;		/* ŏ */

#ifdef	OSKDIS
    lptr = gen( CR , BeginBSS , lptr );
    if( option_S ) {
	output_file_close();
	output_file_open( sfilename , -1 );
    }
#else
    lptr = gen( "\t.text" CR , BeginDATA , lptr );
    if( option_S ) {
	output_file_close();
	output_file_open( sfilename , -1 );
    }
    lptr = gen( CR "\t.data" CR , BeginBSS , lptr );
    if( option_S ) {
	output_file_close();
	output_file_open( sfilename , -2 );
    }
#endif	/* OSKDIS */

    nmode = lptr->mode;
    pc = lptr->label;

#ifdef	OSKDIS
    output_opecode( CR "\tvsect" CR CR );
    while( pc <= BeginDATA ) {
	mode = nmode;
	lptr = Next( lptr );
	nlabel = lptr->label;
	nmode = lptr->mode;

	if (pc == BeginDATA) break; /* D */

	vlabelout( pc , TRUE , mode );
	bssgen( pc , nlabel , mode & 0xff );
	pc = nlabel;
    }

#ifdef	DEBUG
    eprintf( "\nTEST=%08x, DATA=%08x, BSS=%08x, LAST=%08x\n",
		BeginTEXT, BeginDATA, BeginBSS, Last);
#endif	/* DEBUG */
    lptr = next( BeginDATA );	/* vsect ̏f[^̈|Cg */
    switch (HeadOSK.type & 0x0f00) {
	case 0x0100:		/* Program  */
	case 0x0b00:		/* Trap     */
	    idatsiz = Top - (ULONG)Head.base + (ULONG)HeadOSK.idata + 4;
	    lptr = idatagen( BeginDATA + *idatsiz, lptr );  /* vsect ̏f[^o */
	    break;
	default:
	    lptr = idatagen( Last, lptr );
	    break;
    }
    pc = lptr->label;
 /* printf("pc=%08X, last=%08X\n", pc, Last ); */
    output_opecode( CR "\tends" CR );	/* end vsect */

    if (pc < Last) {
	output_opecode( CR "\tvsect\tremote" CR CR);
	while( pc <= Last ) {
	    mode = nmode;
	    lptr = Next( lptr );
	    nlabel = lptr->label;
	    nmode = lptr->mode;

	    if (pc == Last) break;	/* D */

	    vlabelout( pc , TRUE , mode );
	    bssgen( pc , nlabel , mode & 0xff );
	    pc = nlabel;
	}
	output_opecode( CR "\tends" CR );	/* end vsect remote */
    }

    output_opecode( CR "\tends" CR );	/* end psect */
    output_opecode( CR "\tend" CR );
#else
    output_opecode( CR "\t.bss" CR CR );
    while( pc <= Last ) {
	mode = nmode;
	lptr = Next( lptr );
	nlabel = lptr->label;
	nmode = lptr->mode;

	label_line_out( pc , mode );
	if( pc == Last )		/* D */
	    break;
	bssgen( pc , nlabel , mode & 0xff );
	pc = nlabel;
    }

    output_opecode( CR "\t.end\t" );
    label_op_out( Head.exec );
#endif	/* OSKDIS */

    newline( Last );

    output_file_close();
}


/*

  PZNVo͂

  input:
    section : section name ; ".text" or ".data"
    end     : block end address
    lptr    : lblbuf* ( contains block start address )

*/
private lblbuf	*gen( char *section , address end , lblbuf *lptr )
{
    address	nlabel;
    lblmode	mode , nmode = lptr->mode;
    boolean	last_was_table = FALSE;
    address	pc = lptr->label;


    output_opecode( section );
    newline( pc );

    while( pc < end ) {
	mode = nmode;
	lptr = Next( lptr );
	while( lptr->shift ) {
	    lptr = Next( lptr );
	}
	nlabel = lptr->label;
	nmode = lptr->mode;

	if( !last_was_table )
	    label_line_out( pc , mode );

	last_was_table = FALSE;

	if( isPROLABEL( mode ) ) {
	    textgen( pc , nlabel );
	    pc = nlabel;
	} else if( isTABLE( mode ) ) {
	    pc = tablegen( pc , nlabel , mode );
	    lptr = next( pc );
	    nmode = lptr->mode;
	    last_was_table = TRUE;
	} else {
	    datagen( pc , nlabel , mode & 0xff );
	    pc = nlabel;
	}
    }
    return( lptr );
}


#ifdef	OSKDIS
/*

  f[^o͂

  input:
    end     : block end address
    lptr    : lblbuf* ( contains block start address )

*/
private lblbuf	*idatagen( address end , lblbuf *lptr )
{
    address nlabel;
    lblmode mode , nmode = lptr->mode;
    boolean last_was_table = FALSE;
    address pc = lptr->label;
    address wkpc = Top - (ULONG)Head.base + (ULONG)HeadOSK.idata + 8;

    newline( pc );

    while( pc < end ) {
	mode = nmode;
	lptr = Next( lptr );
	while( lptr->shift ) {
	    lptr = Next( lptr );
	}
	nlabel = lptr->label;
	nmode = lptr->mode;

	if( !last_was_table )
	    label_line_out( pc , mode );

	last_was_table = FALSE;

#ifdef	DEBUG
	eprintf( "PC=%08x, NEXT=%08x, MODE=%08x\n", pc, nlabel, mode);
#endif	/* DEBUG */
	wkpc = idatagen_sub(pc, wkpc, nlabel, mode);
	pc = nlabel;
    }
    return( lptr );
}
#endif	/* OSKDIS */


/*

  eLXgubNo͂

  input :
    pc : text begin address
    pcend : text end address

  return :
    pcend

*/
private address textgen( address pc , address pcend )
{
    char	buffer[ 128 ];
    char	*cptr;
    address	store;
    address	store0 , pc0;
    disasm	code;
#ifdef	OSKDIS
    int		os9no;
#else
    int		iocsno;
#endif	/* OSKDIS */

    store = pc + Ofst;

    charout( '.' );
    while( pc < pcend ) {
	buffer[0] = '\0';
	pc0 = pc;
	store0 = store;
	store += dis( store , &code , &pc );

	if( code.op1.operand[0] ) {
	    if( sp_a7_flag ) a7toSP( &code.op1 );
	    labelchange( &code , &code.op1 );
	}
	if( code.op2.operand[0] ) {
	    if( sp_a7_flag ) a7toSP( &code.op2 );
	    labelchange( &code , &code.op2 );
	}
	if( code.op3.operand[0] ) {
	    if( sp_a7_flag ) a7toSP( &code.op3 );
	    labelchange( &code , &code.op3 );
	}
	if( code.op4.operand[0] ) {
	    if( sp_a7_flag ) a7toSP( &code.op4 );
	    labelchange( &code , &code.op4 );
	}

	if( option_N && code.flag == OTHER && code.size == code.default_size )
	    code.size = NOTHING;
	switch( Generate_SizeMode ) {
	case SIZE_NORMAL:
	    if( ( code.flag != OTHER && code.jmpea == PCDISP &&
		  check_displacement( pc , &code ) ) )
		code.size = NOTHING;
	    break;
	case SIZE_OMIT:
	    if( code.flag != OTHER && code.jmpea == PCDISP )
		code.size = NOTHING;
	    break;
	case SIZE_NOT_OMIT:
	    break;
	}
#ifdef	OSKDIS
	if (*(UWORD*)store0 == 0x4e40 &&	/* 0x4e40 == trap #0 (OS9)	*/
	  code.op1.opval < 0x100 &&		/* NGXgԍ $00`$FF	*/
	  OS9label[ os9no = code.op1.opval ]) {
	    strcpy(buffer, "\tOS9\t");
	    strcat(buffer, OS9label[ os9no ]);
	} else if (*(UWORD*)store0 == 0x4e4d &&	/* 0x4e4d == trap #13 (CIO$Trap)*/
	  code.op2.opval < 0x100 &&		/* NGXgԍ $00`$FF	*/
	  CIOlabel[ os9no = code.op2.opval ]) {
	    strcpy(buffer, "\tTCALL\tCIO$Trap,");
	    strcat(buffer, CIOlabel[ os9no ]);
	} else if (*(UWORD*)store0 == 0x4e4f &&	/* 0x4e40 == trap #15 (T$Math)	*/
	  code.op2.opval < 0x100 &&		/* NGXgԍ $00`$FF	*/
	  MATHlabel[ os9no = code.op2.opval ]) {
	    strcpy(buffer, "\tTCALL\tT$Math,");
	    strcat(buffer, MATHlabel[ os9no ]);
	}
#else
	if( code.flag == OTHER && pc < pcend &&
	  *(UBYTE*)store0 == 0x70 &&		/* 0x70xx == moveq.l #xx,d0	*/
	  *(UWORD*)store == 0x4e4f &&		/* 0x4e4f == TRAP #15 opecode	*/
	  IOCSlabel[ iocsno = (int)*(UBYTE*)( store0 + 1 ) ] ) {
	    buffer[0] = '\t';
	    cptr = strcpy2( buffer + 1 , IOCSCallName );
	    *cptr++ = '\t';
	    strcpy2( cptr , IOCSlabel[ iocsno ] );
	    store += 2;
	    pc += 2;
	}
#endif	/* OSKDIS */
	else {
	    cptr = strend( buffer );
	    *cptr++ = '\t';
	    cptr = strcpy2( cptr , code.opecode );
	    if( code.size < NOTHING ) {
		*cptr++ = '.';
		*cptr++ = opsize[ code.size ];
	    }

	    if( code.op1.operand[ 0 ] ) {
		*cptr++ = '\t';

		cptr = strcpy2( cptr , code.op1.operand );

		if( code.op2.operand[ 0 ] ) {
		    if( code.op2.ea != BitField && code.op2.ea != KFactor )
			*cptr++ = ',';
		    cptr = strcpy2( cptr , code.op2.operand );

		    if( code.op3.operand[ 0 ] ) {
			if( code.op3.ea != BitField && code.op3.ea != KFactor )
			    *cptr++ = ',';
			cptr = strcpy2( cptr , code.op3.operand );

			if( code.op4.operand[ 0 ] ) {
			    if( code.op4.ea != BitField && code.op4.ea != KFactor )
				*cptr++ = ',';
			    cptr = strcpy2( cptr , code.op4.operand );
			}
		    }
		}
	    }
	}

	if( option_M ){
	    if( code.op1.ea == IMMED ){
		switch( code.size ){
		case BYTESIZE:
		    if(
		    strnicmp( code.opecode , "cmp"  , 3 ) == 0 ||
		    ((
		    strnicmp( code.opecode , "add"  , 3 ) == 0 ||
		    strnicmp( code.opecode , "sub"  , 3 ) == 0
		    ) && (
		    code.opecode[3] != 'q' && code.opecode[3] != 'Q'
		    )) ||
		    (
		    strnicmp( code.opecode , "move" , 4 ) == 0 &&
		    code.opecode[4] != 'q' && code.opecode[4] != 'Q'
		    )
		    )
			byteout_for_moption( pc0 , buffer , BYTESIZE );
		    break;
		case WORDSIZE:
		case LONGSIZE:
		    if(
		    strnicmp( code.opecode , "cmp"  , 3 ) == 0 ||
		    (
		    strnicmp( code.opecode , "move" , 4 ) == 0 &&
		    code.opecode[4] != 'q' && code.opecode[4] != 'Q'
		    ))
			byteout_for_moption( pc0 , buffer , code.size );
		    break;
		default:
		    break;
		}
	    }
	    if( code.op3.ea == IMMED ){
		if( strnicmp( code.opecode , "pack"  , 4 ) == 0 ||
		    strnicmp( code.opecode , "unpk"  , 4 ) == 0 )


			byteout_for_moption( pc0 , buffer , NOTHING );
	    }
	}

	if( option_x )
	    byteout_for_xoption( pc0 , pc - pc0 , buffer );

	outputa( buffer );
	newline( pc0 );

	if( code.flag == RTSOP ||
	  ( code.flag == JMPOP &&
	    ( tolower( code.opecode[0] ) == 'j' ||	/* RTS ̌ɂ͋s */
	      ( option_B && !strcmpi( code.opecode , "bra" )) )
	  ) )
	    outputa( CR );
    }
    return( pcend );
}



/*

@a7 \L sp \Lɕς

*/
void a7toSP( operand *op )
{
    char *ptr = op->operand;

    switch( op->ea ){
    case AregD:
	break;
    case AregID:
    case AregIDPI:
	ptr++;
	break;
    case AregIDPD:
	ptr+=2;
	break;
    case AregDISP:
	ptr = strchr( ptr , ',' ) + 1;
	break;
    case AregIDX:
	ptr = strchr( ptr , ',' ) + 1;
	if( strnicmp( ptr, "a7", 2 ) == 0 ) {
	    if( option_U ) {
		ptr[0] = 'S';
		ptr[1] = 'P';
	    } else {
		ptr[0] = 's';
		ptr[1] = 'p';
	    }
	}
	ptr += 3;
	break;
    case PCIDX:
	ptr = strrchr( ptr , ',' ) + 1;
	break;


    case RegPairID:
	ptr++;
	if( strnicmp( ptr, "a7", 2 ) == 0 ) {
	    char *p = ptr;
	    if( option_U ) {
		*p++ = 'S';
		*p++ = 'P';
	    } else {
		*p++ = 's';
		*p++ = 'p';
	    }
	}
	ptr+=5;
	break;

    case PCIDXB:
    case PCPOSTIDX:
    case PCPREIDX:
    case AregIDXB:
    case AregPOSTIDX:
    case AregPREIDX:
				/* tgtH[}bg disasm.c ŏ */

    default:
	return;
    }

    if( strnicmp( ptr, "a7", 2 ) == 0 ){
	if(option_U){
	    *ptr++ = 'S';
	    *ptr++ = 'P';
	}else{
	    *ptr++ = 's';
	    *ptr++ = 'p';
	}
    }
    return;
}











#ifdef	OSKDIS
/*

@f[^o͂

*/
idatagen_sub( address pc , address wkpc , address pcend , lblmode mode )
{
    ULONG byte;

    while( pc < pcend ) {
	byte = pcend - pc;
	switch (mode & 0xff) {
	    case LONGSIZE:
		if (byte != 4) goto XX;
		if (mode & CODEPTR) {
		    if (*(ULONG *)wkpc == 0) {
			outputf( DC_L "_btext\t* $%08x" CR, *(ULONG *)wkpc);
		    }
		    else if (*(ULONG *)wkpc == HeadOSK.name) {
			outputf( DC_L "_bname\t* $%08x" CR, *(ULONG *)wkpc);
		    } else {
			outputf( DC_L "L%06x" CR, *(ULONG *)wkpc);
			break;
		    }
		}
		else if (mode & DATAPTR) {
		    outputf( DC_L "L%06x" CR, BeginBSS + *(ULONG *)wkpc);
		}
		else {
		    outputf( DC_L "$%08x" CR, *(ULONG *)wkpc);
		}
		break;
	    case WORDSIZE:
		if (byte != 2) goto XX;
		outputf( DC_W "$%04x" CR, *(UWORD *)wkpc);
		break;
	    default:
XX:		byteout((ULONG)wkpc - (ULONG)Top + (ULONG)Head.base, byte, FALSE);
	}
	pc += byte;
	wkpc += byte;
    }
    return (wkpc);
}
#endif	/* OSKDIS */


/*

  f[^ubNo͂

  input :
    pc : data begin address
    pcend : data end address
    size : data size

  return :
    pcend

*/
private address datagen( address pc , address pcend , opesize size )
{
    address	next_adrs;

    while( pc < pcend ) {
	if( ( next_adrs = nearadrs( pc ) ) < pcend ) {
	    if( next_adrs != pc ) {
		datagen_sub( pc , next_adrs , size );
		pc = next_adrs;
	    }
	    output_opecode( DC_L );
	    label_op_out( *(address*)( next_adrs + Ofst ) );
	    newline( next_adrs );
	    pc += 4;
	} else {
	    datagen_sub( pc , pcend , size );
	    pc = pcend;
	}
    }
    return( pcend );
}


/*

  f[^ubNo͂
   : pc  pcend ܂łɂ̓AhXɈˑĂƂ͂Ȃ

  input :
    pc : data begin address
    pcend : data end address
    size : data size

*/
private void	datagen_sub( address pc , address pcend , opesize size )
{
    switch ( size ) {
    case STRING:
	strgen( pc , pcend );
	break;
    case RELTABLE:
	relgen( pc , pcend );
	break;
    case RELLONGTABLE:
	rellonggen( pc , pcend );
	break;
    case ZTABLE:
	zgen( pc , pcend );
	break;
#ifdef	OSKDIS
    case WTABLE:
	wgen( pc , pcend );
	break;
#endif	/* OSKDIS */
    default:
	dataout( pc , pcend - pc , size );
    }
}


/*

  f[^ubN̏o

  input :
    pc : data begin address
    byte : number of bytes
    size : data size ( UNKNOWN , BYTESIZE , WORDSIZE , LONGSIZE only )

*/
private void	dataout( address pc , ULONG byte , opesize size )
{
    address	store = pc + Ofst;

#ifdef	DEBUG
    printf( "dataout : store %x byte %x size %x\n" , store , byte , size );
#endif

    charout( '#' );
    switch ( size ) {
    case WORDSIZE:
	if( ((long)store & 1 ) || (byte % 2) ){
	    byteout( pc , byte , FALSE );
	}else if( byte == 2 ){
	    output_opecode( DC_W );
	 /* outputax4_without_0supress( *(UWORD*)store ); */
	    outputaxd( *(UWORD*)store , 4 );
	    newline( store - Ofst );
	}else{
	    wordout( pc , byte );
	}
	break;
    case LONGSIZE:
	if( ((long)store & 1 ) || ( byte % 4 ) ){
	    byteout( pc , byte , FALSE );
	}else if( byte == 4 ){
	    output_opecode( DC_L );
	 /* outputax8_without_0supress( *(ULONG*)store ); */
	    outputaxd( *(ULONG*)store , 8 );
	    newline( store - Ofst );
	}else{
	    longout( pc , byte );
	}
	break;
    case BYTESIZE:
	if( byte == 1 ) {
	    output_opecode( DC_B );
	 /* outputax2_without_0supress( *(UBYTE*)store ); */
	    outputaxd( *(UBYTE*)store , 2 );
	    newline( store - Ofst );
	    break;
	}
    case UNKNOWN:
    default:
	byteout( pc , byte , FALSE );
	break;
    }
}


/*

  f[^ubN̏o

  input :
    pc : data begin address
    byte : number of bytes
    roption_flag : hex comment to string flag
    ( case this function is used for string output )

*/
private void	byteout( address pc , ULONG byte , boolean roption_flag )
{
    address	store = pc + Ofst;

#ifndef OSKDIS	/* OS-9/68K  r68 ɂ dcb ɑ^߂ */
    if( !roption_flag && byte >= SAME_CONST_COMPRESS_LENGTH ) {
	int	val = *(UBYTE*)store;
	address	ptr = store;

	while( ptr < store + byte && *(UBYTE*)ptr == val )
	    ptr++;
	if( ptr == store + byte ) {
	    if( val == 0 ) {
		output_opecode( DS_B );
		outputfa( "%d" , byte );
	    } else {
		output_opecode( DCB_B );
		outputfa( "%d," , byte );
		outputax2_without_0supress( val );
	    }
	    newline( pc );
	    return;
	}
    }
#endif	/* !OSKDIS */

    {
	ULONG	max = ( byte - 1 ) / Data_width;
	ULONG	mod = ( byte - 1 ) % Data_width;
	int	i , j;

	for( i = 0 ; i <= max ; i++ ) {
	    if( roption_flag )
		outputa( "*\t\t" );
	    else
		output_opecode( DC_B );
	    for( j = 1 ; j < ( i == max ? mod + 1 : Data_width ) ; j++ ) {
		outputax2_without_0supress( *(UBYTE*)store++ );
		outputca( ',' );
	    }
	    outputax2_without_0supress( *(UBYTE*)store++ );
	    newline( pc );
	}
    }
}


private void	wordout( address pc , ULONG byte )
{
    address	store = pc + Ofst;

#ifndef OSKDIS
    if( byte >= SAME_CONST_COMPRESS_LENGTH ) {
	int	val = *(UWORD*)store;
	address	ptr = store;

	while( ptr < store + byte && *(UWORD*)ptr == val )
	    ptr += 2;
	if( ptr == store + byte ) {
	    if( val == 0 ) {
		output_opecode( DS_W );
		outputfa( "%d" , byte / 2 );
	    } else {
		output_opecode( DCB_W );
		outputfa( "%d," , byte / 2 );
		outputax4_without_0supress( val );
	    }
	    newline( pc );
	    return;
	}
    }
#endif	/* !OSKDIS */

    {
	int	datawidth = ( Data_width + 1 ) / 2;
	ULONG	max = ( byte/2 - 1 ) / datawidth;
	ULONG	mod = ( byte/2 - 1 ) % datawidth;
	int	i , j;

	for( i = 0 ; i <= max ; i++ ) {
	    output_opecode( DC_W );
	    for( j = 1 ; j < ( i == max ? mod + 1 : datawidth ) ; j++ ) {
		outputax4_without_0supress( *(UWORD*)store );
		store += 2;
		outputca( ',' );
	    }
	    outputax4_without_0supress( *(UWORD*)store );
	    store += 2;
	    newline( pc );
	}
    }
}


private void	longout( address pc , ULONG byte )
{
    address	store = pc + Ofst;

#ifndef OSKDIS
    if( byte >= SAME_CONST_COMPRESS_LENGTH ) {
	int	val = *(ULONG*)store;
	address	ptr = store;

	while( ptr < store + byte && *(ULONG*)ptr == val )
	    ptr += 4;
	if( ptr == store + byte ) {
	    if( val == 0 ) {
		output_opecode( DS_L );
		outputfa( "%d" , byte / 4 );
	    } else {
		output_opecode( DCB_L );
		outputfa( "%d," , byte / 4 );
		outputax8_without_0supress( val );
	    }
	    newline( pc );
	    return;
	}
    }
#endif	/* !OSKDIS */

    {
	int	datawidth = ( Data_width + 3 ) / 4;
	ULONG	max = ( byte/4 - 1 ) / datawidth;
	ULONG	mod = ( byte/4 - 1 ) % datawidth;
	int	i , j;

	for( i = 0 ; i <= max ; i++ ) {
	    output_opecode( DC_L );
	    for( j = 1 ; j < ( i == max ? mod + 1 : datawidth ) ; j++ ) {
		outputax8_without_0supress( *(ULONG*)store );
		store += 4;
		outputca( ',' );
	    }
	    outputax8_without_0supress( *(ULONG*)store );
	    store += 4;
	    newline( pc );
	}
    }
}








/*

  -M IvṼRg

  input :
    pc : address of 'cmpi.?, move.b, addi.b, subi.? #??' instruction
    buffer : pointer to output buffer

*/
private void	byteout_for_moption( address pc , char *buffer , int size )
{
    int		i , len , l = 0;
    char	*ptr;
    address	store = pc + Ofst;
    char	*temp;

    switch( size ){
    case BYTESIZE:
	if( !isprint( *(unsigned char*)( store + 3 ) ) )
	    return;
	break;
    case WORDSIZE:
	if(
	!(isprint( *(unsigned char*)( store + 2 ) ) || *(unsigned char*)( store + 2 ) == 0 ) ||
	! isprint( *(unsigned char*)( store + 3 ) )
	)
	    return;
	break;
    case LONGSIZE:
	if(
	!(isprint( *(unsigned char*)( store + 2 ) ) || *(unsigned char*)( store + 2 ) == 0 ) ||
	! isprint( *(unsigned char*)( store + 3 ) ) ||
	! isprint( *(unsigned char*)( store + 4 ) ) ||
	!(isprint( *(unsigned char*)( store + 5 ) ) || *(unsigned char*)( store + 5 ) == 0 )
	)
	    return;
	break;
    default:	/* pack,unpk ̏ꍇɗ */
	if(!( isprint( *(unsigned char*)( store + 2 )) || *(unsigned char*)( store + 2 )==0 ))	return;
	if(!( isprint( *(unsigned char*)( store + 3 )) || *(unsigned char*)( store + 3 )==0 ))	return;
	l  = ( *(unsigned char*)( store + 2 ) ) ? 1 : 0;
	l += ( *(unsigned char*)( store + 3 ) ) ? 2 : 0;
	if( l == 0 )	return;
	break;
    }


    for( len = 0 , ptr = buffer ; *ptr ; ptr++ )	/* s܂ł̒𐔂 */
	len += ( *ptr == 0x09 ? 8 - len % 8 : 1 );

    for( i = Mtab - len / 8 - 1 ; i > 0 ; i-- )
	strcat( buffer , "\t" );

    temp = strend( buffer );
    *temp++ = '\t';
    *temp++ = CommentChar;	/* at least one TAB */
    *temp++ = '\'';

    switch( size ){
    case BYTESIZE:
	*temp++ = *(unsigned char*)( store + 3 );
	break;
    case WORDSIZE:
	if( *(unsigned char*)( store + 2 ) ){
	    *temp++ = *(unsigned char*)( store + 2 );
	}
	*temp++ = *(unsigned char*)( store + 3 );
	break;
    case LONGSIZE:
	if( *(unsigned char*)( store + 2 ) ){
	    *temp++ = *(unsigned char*)( store + 2 );
	}
	*temp++ = *(unsigned char*)( store + 3 );
	*temp++ = *(unsigned char*)( store + 4 );
	if( *(unsigned char*)( store + 5 ) )
	    *temp++ = *(unsigned char*)( store + 5 );
	else{
	    strcpy( temp, "\'*256" );
	    return;
	}
	break;
    default:	    /* pack,unpk̏ꍇ */
	switch( l ){
	case 1:
	    *temp++ = *(unsigned char*)( store + 2 );
	    strcpy( temp, "\'*256" );
	    return;
	case 2:
	    *temp++ = *(unsigned char*)( store + 3 );
	    break;
	case 3:
	    *temp++ = *(unsigned char*)( store + 2 );
	    *temp++ = *(unsigned char*)( store + 3 );
	    break;
	}
    }

    *temp++ = '\'';
    *temp++ = '\0';
}



/*

  -x IvṼRg

  input :
    pc : address of instruction
    byte : instruction length in byte
    buffer : pointer to output buffer

*/
extern void	byteout_for_xoption( address pc , ULONG byte , char *buffer )
{
    int		i , len;
    char	*ptr;
    address	store = pc + Ofst;

    for( len = 0 , ptr = buffer ; *ptr ; ptr++ )
	len += ( *ptr == 9 ? 8 - len % 8 : 1 );

    /* now, ptr points buffer tail */
    for( i = Xtab - len / 8 - 1 ; i > 0 ; i-- )
	*ptr++ = '\t';

    *ptr++ = '\t';		/* at least one TAB */
    *ptr++ = CommentChar;

    for( i = 0 ; i < byte - 2 ; i += 2 , store += 2 ) {
	*ptr++ = '$';
	ptr = itox4_without_0supress( ptr , *(UWORD*)store );
	*ptr++ = ',';
    }
    *ptr++ = '$';
    itox4_without_0supress( ptr , *(UWORD*)store );
}


/*

  ̏o

  input :
    pc : string begin address
    pcend : string end address

*/
#ifdef	OSKDIS
#define ENTERSTR\
    if( !strmode ) {\
	 outputfa( "%s\"" , delimit );\
	 column += ( delimit[ 0 ] ? 2 : 1 );\
	 strmode = TRUE;\
    }
#define EXITSTR\
    if( strmode ) {\
	outputca( '\"' );\
	column ++;\
	strmode = FALSE;\
    }
#else
#define ENTERSTR\
	if( !strmode ) {\
	     outputfa( "%s'" , delimit );\
	     column += ( delimit[ 0 ] ? 2 : 1 );\
	     strmode = TRUE;\
	}
#define EXITSTR\
	if( strmode ) {\
	    outputca( '\'' );\
	    column ++;\
	    strmode = FALSE;\
	}
#endif	/* OSKDIS */

private void	strgen( address pc , address pcend )
{
    address	store = pc + Ofst , store0;
    boolean	strmode;
    char	delimit[ 2 ];
    int		column = 0;

    charout( 's' );

    while( store - Ofst < pcend ) {
	output_opecode( DC_B );
	strcpy( delimit , "" );
	strmode = FALSE;
	column = 0;
	store0 = store;
	while( column < String_width && store - Ofst < pcend ) {
	    if( *(UBYTE*)store == 0x80 ) {			/* pЂ炪 */
		if( 0x86 <= *( store + 1 ) && *( store + 1 ) <= 0xfc &&
		    store + 1 - Ofst < pcend ) {		/* QoCg ... */
		    ENTERSTR;
		    outputca( *(UBYTE*)store++ );
		    outputca( *(UBYTE*)store++ );
		    column += 1;
		} else
		    goto out;
	    } else if( iskanji( *(UBYTE*)store ) ) {		/* Sp */
		if( iskanji2( *(UBYTE*)( store + 1 ) ) &&
		    store + 1 - Ofst < pcend ) {		/* QoCg ... */
		    ENTERSTR;
		    outputca( *(UBYTE*)store++ );
		    outputca( *(UBYTE*)store++ );
		    column += 2;
		} else
		    goto out;
#ifdef	OSKDIS
	} else if( isprkana( *(UBYTE*)store ) && *store != '\"' ) { /* ANK  */
#else
	    } else if( isprkana( *(UBYTE*)store ) && *store != '\'' ) { /* ANK  */
#endif	/* OSKDIS */
		ENTERSTR;
		outputca( *(UBYTE*)store++ );
		column++;
	    } else {
	    out:
		EXITSTR;
		outputfa( "%s" , delimit );
		outputax2_without_0supress( *(UBYTE*)store );
		column += ( delimit[ 0 ] ? 4 : 3 );
		if( store - Ofst + 1 != pcend &&
		    ( *(UBYTE*)store == 0x0a || *(UBYTE*)store == 0 ) &&
		    *(UBYTE*)( store + 1 ) != 0 ) {
		    store++;
		    break;					/* s */
		}
		store++;
	    }
	    strcpy( delimit , "," );
	}
#ifdef	OSKDIS
	if( strmode )
	    outputca( '\"' );
#else
	if( strmode )
	    outputca( '\'' );
#endif	/* OSKDIS */

	newline( store0 - Ofst );
	if( option_r )
	    byteout( store0 - Ofst , store - store0 , TRUE );
    }
}
#undef	ENTERSTR
#undef	EXITSTR


/*

  eBuItZbge[ȕo

  input :
    pc : relative offset table begin address
    pcend : relative offset table end address

*/
private void	relgen( address pc , address pcend )
{
    char	work0[ 128 ] , work1[ 128 ];
    char	*temp;
    address	store = pc + Ofst;
    int		dif;

    charout( 'r' );

    make_proper_symbol( work0 , pc );

    while( store - Ofst < pcend ) {
	dif = (int)*(signed short*)store;
	store += 2;
	if( (LONG)( pc + dif ) < (LONG)BeginTEXT ) {
	    make_proper_symbol( work1 , BeginTEXT );
	    temp = strend( work1 );
	    *temp++ = '-';
	    itox6d( temp , BeginTEXT - ( pc + dif ) );
	} else if( (LONG)( pc + dif ) > (LONG)Last ) {
	    make_proper_symbol( work1 , Last );
	    temp = strend( work1 );
	    *temp++ = '+';
	    itox6d( temp , ( pc + dif ) - Last );
	} else
	    make_proper_symbol( work1 , pc + dif );

	output_opecode( DC_W );
	outputfa( "%s-%s" , work1 , work0 );
	newline( store - 2 - Ofst );
    }
}


/*

  O[hȃeBuItZbge[ȕo

  input :
    pc : relative offset table begin address
    pcend : relative offset table end address

*/
private void	rellonggen( address pc , address pcend )
{
    char	work0[ 128 ] , work1[ 128 ];
    char	*temp;
    address	store = pc + Ofst;
    int		dif;

    charout( 'R' );

    make_proper_symbol( work0 , pc );

    while( store - Ofst < pcend ) {
	dif = (int)*(signed long*)store;
	store += 4;
	if( (LONG)( pc + dif ) < (LONG)BeginTEXT ) {
	    make_proper_symbol( work1 , BeginTEXT );
	    temp = strend( work1 );
	    *temp++ = '-';
	    itox6d( temp , BeginTEXT - ( pc + dif ) );
	} else if( (LONG)( pc + dif ) > (LONG)Last ) {
	    make_proper_symbol( work1 , Last );
	    temp = strend( work1 );
	    *temp++ = '+';
	    itox6d( temp , ( pc + dif ) - Last );
	} else
	    make_proper_symbol( work1 , pc + dif );

	output_opecode( DC_L );
	outputfa( "%s-%s" , work1 , work0 );
	newline( store - 4 - Ofst );
    }
}


#ifdef	OSKDIS
/*

  [he[ȕo

  input:
    pc : word table begin address
    pcend : word table end address

*/
private void	wgen( address pc , address pcend )
{
    char    work[ 128 ];
    char    *temp;
    address store;
    address label;

    charout( 'w' );

    for( store = pc + Ofst ; store + 2 <= pcend + Ofst ; store += 2 ) {
	label = (int)*(signed short*)store;
	if( (LONG)label < (LONG)BeginTEXT ) {
	    make_proper_symbol( work , BeginTEXT );
	    temp = strend( work );
	    *temp++ = '-';
	    itox6d( temp , (ULONG)( BeginTEXT - label ) );
	} else if( (LONG)label > (LONG)Last ) {
	    make_proper_symbol( work , Last );
	    temp = strend( work );
	    *temp++ = '+';
	    itox6d( temp , (ULONG)( label - Last ) );
	} else {
	    make_proper_symbol( work ,  label );
	}
	output_opecode( DC_W );
	outputa( work );
	newline( store - Ofst );
    }
    if( store != pcend + Ofst )
	dataout( store  - Ofst , pcend + Ofst - store , UNKNOWN );
}
#endif	/* OSKDIS */

/*

  O[he[ȕo

  input :
    pc : longword table begin address
    pcend : longword table end address

*/
private void	zgen( address pc , address pcend )
{
    char	work[ 128 ];
    char	*temp;
    address	store;
    address	label;

    charout( 'z' );

    for( store = pc + Ofst ; store + 4 <= pcend + Ofst ; store += 4 ) {
	label = *(address*)store;
	if( (LONG)label < (LONG)BeginTEXT ) {
	    make_proper_symbol( work , BeginTEXT );
	    temp = strend( work );
	    *temp++ = '-';
	    itox6d( temp , (ULONG)( BeginTEXT - label ) );
	} else if( (LONG)label > (LONG)Last ) {
	    make_proper_symbol( work , Last );
	    temp = strend( work );
	    *temp++ = '+';
	    itox6d( temp , (ULONG)( label - Last ) );
	} else {
	    make_proper_symbol( work , label );
	}
	output_opecode( DC_L );
	outputa( work );
	newline( store - Ofst );
    }
    if( store != pcend + Ofst )
	dataout( store - Ofst , pcend + Ofst - store , UNKNOWN );
}


/*

  [U[`̃e[ȕo

  input :
    pc : user defined table begin address
    pcend : user defined table end address( not used )
    mode : table attribute( not used )
  return :
    table end address

*/
#define debug	if(0)printf
static boolean	end_by_break;

private address tablegen( address pc , address pcend , lblmode mode )
{
    int		loop , i;
    table	*tableptr;

    debug( "enter tablegen\n" );

    charout( 't' );
    if( ( tableptr = search_table( pc ) ) == NULL ) {
	err( 1 , "Table  %06x (!?)\n" , pc );
    }

    end_by_break = FALSE;
    pc = tableptr->tabletop;

    for( loop = 0 ; loop < tableptr->loop ; loop++ ) {	/* implicit loop */
	for( i = 0 ; i < tableptr->lines ; i++ ) {	/* line# loop */
	    debug( "loop=%d i=%d\n" , loop , i );
	    pc = tablegen_sub( &( tableptr->formulaptr[ i ] ) ,
			       tableptr->tabletop , pc , i + 1 < tableptr->lines );
	 /* if( ( lptr = search_label( Eval_PC ) ) != NULL ) {
		debug("THERE IS LABEL (%x)\n" , Eval_PC);
		label_line_out( Eval_PC , FALSE );
	    } */
	    if( end_by_break ) {
		goto ret;
	    }
	}
    }

 ret:
    debug( "exit tablegen\n" );
    return( pc );
}


/*

  [U`̃e[ȕo

  input :
    exprptr : [U`̃e[uPs̍\
    tabletop : table top address
    pc : pointing address
    notlast : true iff this line is not last line at table
  return :
    next pointing address

*/
private address tablegen_sub( formula *exprptr
				, address tabletop , address pc , int notlast )
{
    int		i , str_length;
    address	pc0 , nextlabel;
    opesize	nextmode;
    lblbuf	*lptr;
    boolean	pc_inc_inst = FALSE;
    extern int	yyparse( void );

    ParseMode = PARSE_GENERATING;
    Eval_TableTop = tabletop;
    Eval_Count = 0;
    Eval_PC = pc;

    do {
	i = 0;
	lptr = next( Eval_PC + 1 );
	nextlabel = lptr->label;
	nextmode = lptr->mode;

	Eval_ResultString[0] = '\0';
	Lexptr = exprptr->expr;

	debug("%d parsing %s\n" , i ,Lexptr );
	yyparse();
	pc0 = Eval_PC;
	switch( exprptr->id ) {
	case LONGSIZE:
	    if( nextlabel < Eval_PC + 4 )
		tablegen_label( Eval_PC , Eval_PC + 4 , lptr );
	    else {
		output_opecode( DC_L );
		outputa( Eval_ResultString );
		newline( Eval_PC );
	    }
	    Eval_PC += 4;
	    pc_inc_inst = TRUE;
	    break;
	case WORDSIZE:
	    if( nextlabel < Eval_PC + 2 )
		tablegen_label( Eval_PC , Eval_PC + 2 , lptr );
	    else {
		output_opecode( DC_W );
		outputa( Eval_ResultString );
		newline( Eval_PC );
	    }
	    pc_inc_inst = TRUE;
	    Eval_PC += 2;
	    break;
	case BYTESIZE:
	    output_opecode( DC_B );
	    outputa( Eval_ResultString );
	    newline( Eval_PC );
	    pc_inc_inst = TRUE;
	    Eval_PC++;
	    break;
#if 0
	case LONGID:
	    if( nextlabel < Eval_PC + Eval_Bytes*4 )
		tablegen_label( Eval_PC , Eval_PC + Eval_Bytes*4 , lptr );
	    else
		datagen( Eval_PC , Eval_PC + Eval_Bytes*4 , LONGSIZE );
	    pc_inc_inst = TRUE;
	    Eval_PC += Eval_Bytes*4;
	    break;

	case WORDID:
	    if( nextlabel < Eval_PC + Eval_Bytes*2 )
		tablegen_label( Eval_PC , Eval_PC + Eval_Bytes*2 , lptr );
	    else
		datagen( Eval_PC , Eval_PC + Eval_Bytes*2 , WORDSIZE );
	    pc_inc_inst = TRUE;
	    Eval_PC += Eval_Bytes*2;
	    break;
#endif
	case BYTEID:
	    if( nextlabel < Eval_PC + Eval_Bytes )
		tablegen_label( Eval_PC , Eval_PC + Eval_Bytes , lptr );
	    else
		datagen( Eval_PC , Eval_PC + Eval_Bytes , BYTESIZE );
	    pc_inc_inst = TRUE;
	    Eval_PC += Eval_Bytes;
	    break;
	case ASCIIID:
	    if( nextlabel < Eval_PC + Eval_Bytes )
		tablegen_label( Eval_PC , Eval_PC + Eval_Bytes , lptr );
	    else
		strgen( Eval_PC , Eval_PC + Eval_Bytes );
	    pc_inc_inst = TRUE;
	    Eval_PC += Eval_Bytes;
	    break;
	case ASCIIZID:
	    str_length = strlen( (char*)Eval_PC + Ofst ) + 1;
	    if( nextlabel < Eval_PC + str_length )
		tablegen_label( Eval_PC , Eval_PC + str_length , lptr );
	    else
		strgen( Eval_PC , Eval_PC + str_length );
	    pc_inc_inst = TRUE;
	    Eval_PC += str_length;
	    break;
	case LASCIIID:
	    str_length = *(unsigned char*)( Eval_PC + Ofst );
	    datagen( Eval_PC , Eval_PC + 1 , BYTESIZE );
	    Eval_PC++;
	    if( nextlabel < Eval_PC + str_length )
		tablegen_label( Eval_PC , Eval_PC + str_length , lptr );
	    else
		strgen( Eval_PC , Eval_PC + str_length );
	    pc_inc_inst = TRUE;
	    Eval_PC += str_length;
	    break;
	case EVENID:
#ifdef	OSKDIS
	    output_opecode( "\talign" );
#else
	    output_opecode( "\t.even" );
#endif	/* OSKDIS */
	    newline( Eval_PC );
	    pc_inc_inst = (boolean)( (int)Eval_PC & 1 );
	    Eval_PC += ( (int)Eval_PC & 1 );
	    break;
	case CRID:
	    newline( Eval_PC );
	    pc_inc_inst = FALSE;
	    break;
	case BREAKID:
	    pc_inc_inst = FALSE;
	    if( Eval_Break ) {
		debug( "END_BY_BREAK!(%x)\n" , (unsigned int)Eval_PC );
		end_by_break = TRUE;
		goto tableend;
	    }
	    break;
	default:	/* reduce warning message */
	    ;
	}
	if( ( lptr = search_label( Eval_PC ) ) != NULL ) {
	    debug( "THERE IS LABEL sub (%x)%x\n" , (unsigned int)Eval_PC , lptr->mode );
#if 0 /* does not work properly */
	    if( isTABLE( lptr->mode ) && notlast ) {
		err( 0 , "\nEncounter another table in table(%x).\n" , Eval_PC );
	    }
#endif
	    if( isENDTABLE( lptr->mode ) ) {
		/* if .even here.... */
		if( notlast && (exprptr+1)->id == EVENID ) {
#ifdef	OSKDIS
		    output_opecode( "\talign" );
#else
		    output_opecode( "\t.even" );
#endif	/* OSKDIS */
		    newline( Eval_PC );
		    Eval_PC += ( (int)Eval_PC & 1 );
		}
		label_line_out( Eval_PC , FALSE );
		debug( "ENCOUNTER ENDTABLE(%x)" , (unsigned int)Eval_PC );
		end_by_break = TRUE;
		goto tableend;
	    } else if( pc_inc_inst )
		/* labelout is not required at end of table */
		label_line_out( Eval_PC , FALSE );
	}
	i++;
    } while( --Eval_Count > 0 );
 tableend:
    debug( "exit tablegen_sub()\n" );
    return( Eval_PC );
}


/*

  e[uɃx݂ꍇ̃f[^ubNo

  input :
    pc : point address
    pcend : point address' end address
    lptr : e[ũx

*/
private void	tablegen_label( address pc , address pcend , lblbuf *lptr )
{
    address	nlabel = lptr->label;
    lblmode	mode , nmode = lptr->mode;

    debug( "tablegen_label(%x,%x,%x)\n" , (unsigned int)pc
					, (unsigned int)pcend
					, (unsigned int)nlabel );
    pc = datagen( pc , nlabel , nmode & 0xff );
    while( pc < pcend ) {
	mode = nmode;
	lptr = next( pc + 1 );
	while( lptr->shift )
	    lptr = Next( lptr );

	nlabel = lptr->label;
	nmode = lptr->mode;

	label_line_out( pc , mode );
	if( isPROLABEL( mode ) )
	    pc = textgen( pc , min( nlabel , pcend ) );
	else
	    pc = datagen( pc , min( nlabel , pcend ) , mode & 0xff );
    }
    debug( "exit tablegen_label\n" );
}


/*

  bss ̈̏o

  input :
    pc : data begin address
    pcend : data end address
    size : data size

*/
private void	bssgen( address pc , address nlabel , opesize size )
{
    ULONG	byte;

    charout( '$' );
    nlabel = (address)min( (ULONG)nlabel , (ULONG)Last );
    byte = nlabel - pc;

    if( (LONG)nlabel >= 0 ) {
	if( byte == 0 )
	    newline( pc );
	else {
	    switch ( size ) {
	    case WORDSIZE:
		if( byte != 2 ) goto out;
		output_opecode( DS_W "1" );
		newline( pc );
		break;
	    case LONGSIZE:
		if( byte != 4 ) goto out;
		output_opecode( DS_L "1" );
		newline( pc );
		break;
	    case BYTESIZE:
	    case UNKNOWN:
	    default:
	    out:
		output_opecode( DS_B );
		outputfa( "%d" , byte );
		newline( pc );
	    }
	}
    }
}


/*

  x̕tւ

  input :
    code : disassembled opecode
    operand : operand ( op1,op2,op3 or op4 )

  return :
    TRUE if output is 'label[+-]??' style ( used to avoid as.x bug )
    ()as.xɂ͑ΉȂȂׁAԒl͍폜.

	Ablong		PCDISP		IMMED	    PCIDX
    0	(label)		(label,pc)	#label	    (label,pc,ix)
    1	(label-$num)	(label-$num,pc)	#label-$num (label-$num,pc,ix)
    2	(label+$num)	(label+$num,pc)	#label+$num (label+$num,pc,ix)

(odexod4̎label)
	PCIDXB		    PCPOSTIDX		    PCPREIDX
	(label,pc,ix)	    ([label,pc],ix,label)   ([label,pc,ix],label)

(bd,odexbd,exodꂼ4̎label)
	AregIDXB	    AregPOSTIDX		    AregPREIDX
	(label,an,ix)	    ([label,an],ix,label)   ([label,an,ix],label)

*/
extern void	labelchange( disasm *code , operand *op )
{
    address arg1;
    LONG    shift;
    char    *ext_operand = NULL;
    char    buff[ 128 ];
    char    *base = buff;

    if( op->opval != (address)-1 &&
      ( op->labelchange1 ||
	( ( op->ea == AbLong || ((op->ea == IMMED) && (code->size2 == LONGSIZE)) )
	&& INPROG( op->opval , op->eaadrs ) )
      )
    ) {
	switch( op->ea ){
	case IMMED:
	default:
	    break;
	case AbLong:
	/*  ext_operand = strchr( op->operand , ')' );  */
	    ext_operand = ")";
	    break;
	case PCDISP:
	    if( (char)op->labelchange1 < 0 )
		break;		/* bsr label ͊ʂȂ */
	case PCIDX:
	case AregIDXB:
	case AregPOSTIDX:
	case AregPREIDX:
	    ext_operand = strchr( op->operand , ',' );
	    break;
	case PCIDXB:
	case PCPOSTIDX:
	case PCPREIDX:
	    ext_operand = strchr( op->operand , ',' );
	    if( *(ext_operand-2) == '.' )
		ext_operand-=2;	/* TCYtȂt */
	    break;
	}

	if( (LONG)op->opval < (LONG)BeginTEXT ) {
	    arg1 = BeginTEXT;
	    shift = (LONG)op->opval - (LONG)BeginTEXT;
	} else if( (ULONG)op->opval > (ULONG)Last ) {
	    arg1 = Last;
	    shift = (ULONG)op->opval - (ULONG)Last;
	} else {
	    lblbuf  *label_ptr;

	    if( ( label_ptr = search_label( op->opval ) ) == NULL )
		return;
	    else {
		if( (shift = label_ptr->shift) ) {
		    arg1 = op->opval - shift;
		} else {
		    arg1 = op->opval;
		    shift = 0;
		}
	    }
	}

	switch( op->ea ){
	default:
	    break;
	case IMMED:
	    *base++ = '#';
	    break;
	case PCDISP:
	    if( (char)op->labelchange1 < 0 )
		break;		/* bsr label ͊ʂȂ */
	case AbLong:
	case PCIDX:
	case AregIDXB:
	case PCIDXB:
	    *base++ = '(';
	    break;
	case AregPOSTIDX:
	case AregPREIDX:
	case PCPOSTIDX:
	case PCPREIDX:
	    *base++ = '(';
	    *base++ = '[';
	    break;
	}

	base = make_symbol( base , arg1 , shift );

	if( ext_operand != NULL )
	    strcpy( base , ext_operand );

	strcpy( op->operand , buff );
    }


/* AE^fBXv[Xgp */
    if( op->labelchange2 &&
	op->opval2 != (address)-1 &&
	INPROG( op->opval2, op->eaadrs2)
    ){
	ext_operand = strrchr( op->operand , ',' );

	if( (LONG)op->opval2 < (LONG)BeginTEXT ) {
	    arg1 = BeginTEXT;
	    shift = (LONG)op->opval2 - (LONG)BeginTEXT;
	} else if( (ULONG)op->opval2 > (ULONG)Last ) {
	    arg1 = Last;
	    shift = (ULONG)op->opval2 - (ULONG)Last;
	} else {
	    lblbuf  *label_ptr;

	    if( ( label_ptr = search_label( op->opval2 ) ) == NULL )
		return;
	    else {
		if( (shift = label_ptr->shift) ) {
		    arg1 = op->opval2 - shift;
		} else {
		    arg1 = op->opval2;
		    shift = 0;
		}
	    }
	}

	base = buff;
	strncpy( base, op->operand, ext_operand - op->operand );
	base += ext_operand - op->operand;
	*base++ = ',';
	base = make_symbol( base , arg1 , shift );
	*base++ = ')';
	*base++ = '\0';

	strcpy( op->operand , buff );
    }
}


/* x`s̃Ro */
private INLINE void add_extern_colon( char *ptr )
{
    switch( SymbolColonNum ) {
	case 3:
	case 2:			/* -C2 && O`Ȃ '::' */
	    *ptr++ = ':';
	case 1:
	    *ptr++ = ':';
	case 0:
	    *ptr = '\0';
	    break;
    }
}

private INLINE void add_static_colon( char *ptr )
{
    switch( SymbolColonNum ) {
	case 3:
	    *ptr++ = ':';
	case 2:			/* -C2 && !O`Ȃ ':' */
	case 1:
	    *ptr++ = ':';
	case 0:
	    *ptr = '\0';
	    break;
    }
}

/*

  x`so

  input :
    adrs : label address
    mode : label mode

  V{`Ă΁uV{::vA`ȂuLxxxxxx:v
  Ȃǂ̌`ŏo͂(R̐⃉x擪̓IvV̏Ԃŕς).
  V{ɂĂ͑So͂ȂƂ.
  make_symbol()}shift폜ARtǉł.

  V{̕`ɑΉ牘ȂĂ܂...

*/
private void	label_line_out( address adrs , lblmode mode )
{
    char	buff[ 128 ];
    symbol	*symbol_ptr;

    if( isHIDDEN( mode ) )
	return;

    if( Exist_symbol && ( symbol_ptr = symbol_search( adrs ) ) != NULL ) {
	symlist *symlistptr;
	char *ptr;

	strcpy( buff , symbol_ptr->sym );
	ptr = strend( buff );
	if( symbol_ptr->type == 0 ) add_static_colon( ptr );
	else			    add_extern_colon( ptr );

	for( symlistptr = symbol_ptr->next ; symlistptr != NULL ;
	     symlistptr = symlistptr->next )
	{
	    outputa( buff );
	    newline( adrs );

	    strcpy( buff , symlistptr->sym );
	    ptr = strend( buff );
	    if( symbol_ptr->type == 0 ) add_static_colon( ptr );
	    else			add_extern_colon( ptr );
	}
    } else {
	char *ptr = buff;
	*ptr++ = Label_first_char;
	ptr = itox6_without_0supress( ptr , (ULONG)adrs );
	add_static_colon( ptr );
    }
    outputa( buff );
    newline( adrs );
}



/*

  IyhƂẴxo

  input :
    adrs : label address
    mode : label mode

  .endy.dc.l^߂̃Iyh쐬ׂɌĂ΂.
  R͕tȂ.
  +-shtt\.

*/
private void	label_op_out( address adrs )
{
    char	buff[ 128 ];

    make_proper_symbol( buff , adrs );
    outputa( buff );
}



#ifdef	OSKDIS
/*

  vsect xo

  input :
    adrs : label address
    colon : if TRUE , output as beginning-of-line label
    mode : label mode

*/
private void	vlabelout( address adrs , boolean colon , lblmode mode )
{
    char    buff[ 128 ];

    if( isHIDDEN( mode ) )
	return;

    if( colon )
	make_symbol( buff , adrs , 0 );
    else
	make_proper_symbol( buff , adrs );

    outputa( buff );

    if( colon ) {
	if( !option_C )
	    outputca( ':' );
    }		/* 񏉊 vsect ̓x̋Lq͏oȂ */
}
#endif	/* OSKDIS */


/*

  xV{̐

  input :
    buff : buffer of label symbol
    adrs : address

  ł߂V{TAlȂshiftlvZ
  make_symbol()Ăяo.

*/
extern void	make_proper_symbol( char *buff , address adrs )
{
    address	arg1;
    LONG	shift;
    lblbuf	*lblptr;

    if( (LONG)adrs < (LONG)BeginTEXT ) {	/* must be LONG , not ULONG */
	arg1 = BeginTEXT;
	shift = (LONG)adrs - (ULONG)BeginTEXT;
    } else if( (ULONG)adrs > (ULONG)Last ) {
	arg1 = Last;
	shift = (ULONG)adrs - (ULONG)Last;
    } else {
	if( ( lblptr = search_label( adrs ) ) != NULL && ( shift = lblptr->shift ) ) {
	    arg1 = adrs - shift;
	} else {
	    arg1 = adrs;
	    shift = 0;
	}
    }
    make_symbol( buff , arg1 , shift );
}


/*

  V{𐶐

  input :
    ptr : symbol buffer
    adrs : address
    sft : shift count
    colon : colon ̎( -C option )  0 ȂtȂ

  return :
    pointer to generated symbol' tail

  V{e[u΁Aadrs ̓V{ɒuAȂ L?????? `ƂȂ
  sft != 0 Ȃ炻̌ +sft or -sft 

  x`s̐ɂlabel_line_out()g.

*/
extern char	*make_symbol( char *ptr , address adrs , LONG sft )
{
    symbol	*symbol_ptr;

    if( Exist_symbol && ( symbol_ptr = symbol_search( adrs ) ) != NULL ) {
	strcpy( ptr , symbol_ptr->sym );
	ptr = strend( ptr );
    } else {
	*ptr++ = Label_first_char;
	ptr = itox6_without_0supress( ptr , (ULONG)adrs );
    }

    if( sft == 0 )
	return( ptr );

    if( sft > 0 ) {
	*ptr++ = '+';
	return( itox6d( ptr , sft ) );
    } else {
	*ptr++ = '-';
	return( itox6d( ptr , -sft ) );
    }
}


private char	*ctimez( time_t *clock )
{
    char *p;
    p = ctime( clock );
    p[24] = '\0';
    return p;
}


/*

  wb_

  input :
    filename : execute filename
    filedate : execute file' time stamp
    argc	: same to argc given to main()
    argv	: same to argv given to main()

*/
private void	makeheader( char *filename , time_t filedate
				, int argc , char *argv[] )
{
    int		i;
    char	*envptr;
    time_t	temp = time( NULL );
    char	buffer[256];

    static char op_include[] = ".include";
    static char op_cpu[]     = ".cpu";
    static char op_fpid[]    = ".fpid";
    static char op_equ[]     = ".equ";

    if( option_U ) {
	strupr( op_include );
	strupr( op_cpu );
	strupr( op_fpid );
	strupr( op_equ );
    }

    outputf( "%c=============================================" CR , CommentChar );
    outputf( "%c  Filename %s" CR , CommentChar, filename );
    outputf( "%c  Time Stamp %s" CR , CommentChar , ctimez( &filedate ) );
    outputf( "%c" CR , CommentChar );
#ifndef OSKDIS
    outputf( "%c  Base address %06x" CR , CommentChar, Head.base );
    outputf( "%c  Exec address %06x" CR , CommentChar, Head.exec );
    outputf( "%c  Text size    %06x byte(s)" CR , CommentChar, Head.text );
    outputf( "%c  Data size    %06x byte(s)" CR , CommentChar, Head.data );
    outputf( "%c  Bss  size    %06x byte(s)" CR , CommentChar, Head.bss );
#endif	/* !OSKDIS */
    outputf( "%c  %d Labels" CR , CommentChar, get_Labelnum() );
    outputf( "%c  Code Generate date %s" CR , CommentChar, ctimez( &temp ) );

    if( ( envptr = getenv( DIS_ENVNAME ) ) != NULL )
	outputf( "%c  Environment %s" CR , CommentChar,
		/* option_Q ? "is ignored (-Q option)" : */ envptr );

    outputf( "%c  Command Line " , CommentChar );
    for( i = 0 ; i < argc ; i++ )
	outputf( "%s " , argv[ i ] );
    outputf( CR );
#ifdef	OSKDIS
    outputf( "*          DIS version %s" CR , Version );
    outputf( "*********************************************" CR );

    outputf( "*  Revision    %04x" CR, HeadOSK.sysrev);
    outputf( "*  Module Size %d bytes" CR, HeadOSK.size);
    outputf( "*  Owner       %d.%d" CR, HeadOSK.owner/65536, HeadOSK.owner&0x0FFFF);
    outputf( "*  Name Offset %08x" CR, HeadOSK.name);
    outputf( "*  Permit      %04x" CR, HeadOSK.accs);
    outputf( "*  Type/Lang   %04x" CR, HeadOSK.type);
    outputf( "*  Attribute   %04x" CR, HeadOSK.attr);
    outputf( "*  Edition     %d" CR, HeadOSK.edition);
    outputf( "*  Entry       %08x" CR, HeadOSK.exec);
    outputf( "*  Excpt       %08x" CR, HeadOSK.excpt);

    if ((HeadOSK.type & 0x0F00) == 0x0e00 ||	/* Driver   */
	(HeadOSK.type & 0x0F00) == 0x0b00 ||	/* Trap     */
	(HeadOSK.type & 0x0F00) == 0x0100) {	/* Program  */
	outputf( "*  Memory Size %d" CR, HeadOSK.mem);
    }
    if ((HeadOSK.type & 0x0F00) == 0x0100 ||	/* Program  */
	(HeadOSK.type & 0x0F00) == 0x0b00) {	/* Trap     */
	outputf( "*  Stack Size  %d" CR, HeadOSK.stack);
	outputf( "*  M$IData     %08x" CR, HeadOSK.idata);
	outputf( "*  M$IRefs     %08x" CR, HeadOSK.irefs);
    }
    if ((HeadOSK.type & 0x0F00) == 0x0b00) {	/* Trap     */
	outputf( "*  M$Init      %08x" CR, HeadOSK.init);
	outputf( "*  M$Term      %08x" CR, HeadOSK.term);
    }

    outputf( "*********************************************" CR );
    outputf( "*" CR);
    strcpy(buffer, Top - (ULONG)Head.base + HeadOSK.name);  /* W[ */
    switch (HeadOSK.type & 0x0F00) {
	case 0x0100:	/* Program */
	case 0x0b00:	/* Trap    */
	    outputf("\tpsect\t%s,$%04x,$%04x,", buffer, HeadOSK.type, HeadOSK.attr);
	    outputf("%d,%d,", HeadOSK.edition, HeadOSK.stack);
	    outputf("L%06x", HeadOSK.exec);
	    if (HeadOSK.excpt) outputf(",L%06x", HeadOSK.excpt);
	    break;
	case 0x0200:	/* Subroutine */
	case 0x0c00:	/* System     */
	case 0x0d00:	/* FileMan    */
	case 0x0e00:	/* Driver     */
	    outputf("\tpsect\t%s,$%04x,$%04x,", buffer, HeadOSK.type, HeadOSK.attr);
	    outputf("%d,%d,", HeadOSK.edition, 0);
	    outputf("L%06x", HeadOSK.exec);
	    if (HeadOSK.excpt) outputf(",L%06x", HeadOSK.excpt);
	    break;
    }
#else
    outputf( "%c          DIS version %s" CR , CommentChar, Version );
    outputf( "%c=============================================" CR CR , CommentChar );

    if( ( envptr = getenv( "dis_header" ) ) == NULL ) {
    def:
	outputf( "\t%s\t%s" CR , op_include , Doscall_mac_path );
	outputf( "\t%s\t%s" CR , op_include , Iocscall_mac_path );
	outputf( "\t%s\t%s" CR , op_include , Fefunc_h_path );
	if( Disasm_SX_Window && Sxcall_mac_path != NULL )
	    outputf( "\t%s\t%s" CR , op_include , Sxcall_mac_path );
	outputf( CR );
    } else {
	FILE *fp;
	if( ( fp = fopen( envptr , "rt" ) ) == NULL ) {
	    err( 0 , "cannot open %s. use default.\n" , envptr );
	    goto def;
	}
	while( fgets( buffer , 128 , fp ) ) {
	    char *p;
	    if( (p = strchr( buffer , '\n' )) != NULL )
		*p = '\0';
	    outputf( "%s" CR , buffer );
	}
	fclose( fp );
    }
#endif	/* OSKDIS */

    outputf( "\t%s\t680%02d" CR , op_cpu , MPU_type );
    for( i = 0 ; i <= 7 ; i++ )
	if( (i != 1) && FPCP_ID[ i*2 ] )
	    outputf( "\t%s\t%d" CR , op_fpid , i );
    outputf( CR CR );

    {
	int i , n;
	if( (n = get_constsymbol_num()) ) {
	    for( i = 0 ; i < n ; i++ ) {
		const_symbol *p = get_constsymbol( i );
		outputf( "%s::\t%s%s\t$%x" CR	    /* tab-2 */
			, p->sym , ( strlen( p->sym ) < (8-2) ) ? "\t" : ""
			, op_equ , p->adrs );
	    }
	    outputf( CR CR );
	}
    }
}


/*

  IyR[h̏o

  input :
    ptr : buffer of opecode ( like "move.l",0 )

*/
private void	output_opecode( char *ptr )
{
    if( option_U ) {
	char	buff[ 20 ];

	strcpy( buff , ptr );
	strupr( buff );
	outputa( buff );
    } else
	outputa( ptr );
}


/* EOF */
