/* $Id: labelfile.c,v 1.1 1996/11/07 08:03:48 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	xt@CW[
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

#include	<stdio.h>
#ifdef unix
#include	<ctype.h>
#else
#ifdef MYU_HEADERS
    #include	<ctype.h>	/* tolower */
#else
    #include	<fctype.h>	/* ctype is bad because macro expansion */
				/* causes twice evaluation. */
#endif
#endif
#include	<string.h>
#include	"estruct.h"
#include	"global.h"
#include	"label.h"
#include	"analyze.h"
#include	"etc.h"
#include	"symbol.h"


/************************ xt@Cւ̏o ************************/


/*

  xt@C̃wb_

*/
private INLINE void	make_header( FILE *fp , char *filename )
{
    fprintf( fp , "*********************************************\n"
		  "*\n"
		  "*  Label file for %s\n"
		  "*\n"
		  "*		  DIS version %s\n"
		  "*\n"
		  "*********************************************\n"
		, filename , Version );
}


/*

  xt@Co

*/
extern void	make_labelfile( char *xfilename , char *labelfilename )
{
    FILE	*fp;
    lblbuf	*nadrs;

    if( ( fp = fopen( labelfilename , "w" ) ) == NULL ) {
	err( 0 , "%s I[vł܂łB\n" , labelfilename );
	return;
    }

    make_header( fp , xfilename );
    nadrs = next( BeginTEXT );

    while( nadrs->label != (address)-1 ) {
	fprintf( fp , "%06x\t" , (unsigned int)nadrs->label );
	if( isPROLABEL( nadrs->mode ) )
	    fputc( 'P' , fp );
	else {
	    fputc( 'D' , fp );
	    switch( nadrs->mode & 0xff ) {
	    case STRING :
		fputc( 'S' , fp );
		break;
	    case RELTABLE :
		fputc( 'R' , fp );
		break;
	    case RELLONGTABLE :
		fputc( 'R' , fp );
		fputc( 'L' , fp );
		break;
	    case ZTABLE :
		fputc( 'Z' , fp );
		break;
	    case BYTESIZE :
		fputc( 'B' , fp );
		break;
	    case WORDSIZE :
		fputc( 'W' , fp );
		break;
	    case LONGSIZE :
		fputc( 'L' , fp );
		break;
	    default:
		fputc( 'U' , fp );
		break;
	    }
	}
	if( nadrs->mode & FORCE )
	    fputc( 'F' , fp );

	{
	    symbol *ptr = symbol_search( nadrs->label );
	    if( ptr ) {
		symlist *symlistptr;
		fprintf( fp , "\t%s" , ptr->sym );
		for( symlistptr = ptr->next ; symlistptr != NULL ;
		     symlistptr = symlistptr->next ) {
		    fprintf( fp , " %s" , symlistptr->sym );
		}
	    }
	}

	fputc( '\n' , fp );
/*	nadrs = next( nadrs->label + 1 );*/
	nadrs = Next( nadrs );
    }
    fclose( fp );
}



/*********************** xt@C̓ ***********************/


/*

  xt@ĈPs͂

  pass = 0, 啶̂ݔ
	 1, ̂ݔ

*/

private INLINE	char *skipspace( char *ptr )
{
    while( ( *ptr == ' ' ) || ( *ptr == '\t' ) )
	ptr++;
    return ptr;
}
private INLINE	char *untilspace( char *ptr )
{
    while( *ptr && ( *ptr != ' ' ) && ( *ptr != '\t' ) )
	ptr++;
    return ptr;
}

private INLINE int	getline( char *linebuf , int line , int pass
				, address *adrs , char **symptrptr )
{
    address	ad;
    char	*ptr = linebuf;
    opesize	attr = 0;

    ad = (address)atox( linebuf );
    ptr = skipspace( untilspace( ptr ) );
    if( Debug & BDEBUG )
	printf( "%x , %c\n" , (unsigned int)ad , *ptr );

    if( ( pass == 0 && islower( *ptr ) ) ||
	( pass == 1 && isupper( *ptr ) ) ) {
	attr = -1;
    } else {
	switch( toupper( *ptr ) ) {
	case 'P' :
	    attr = PROLABEL;
	    break;
	case 'D' :
	    attr = DATLABEL;
	    switch( toupper( *++ptr ) ) {
	    case 'S' :
		attr |= STRING;
		break;
	    case 'R' :
		attr |= RELTABLE;
		if( toupper( ptr[1] ) == 'L' ){
		    ptr++;
		    attr &= ~RELTABLE;
		    attr |= RELLONGTABLE;
		}
		break;
	    case 'Z' :
		attr |= ZTABLE;
		break;
	    case 'B' :
		attr |= BYTESIZE;
		break;
	    case 'W' :
		attr |= WORDSIZE;
		break;
	    case 'L' :
		attr |= LONGSIZE;
		break;
	    case 'U' :
		attr |= UNKNOWN;
		break;
	    default:
		goto er;
	    }
	    break;
	default:
	er:
	    err( 1 , "\nlabelfile %ds address %x : sȕł\n" , line , ad );
	}
	if( toupper( *++ptr ) == 'F' )
	    attr |= FORCE;
    }

    *symptrptr = skipspace( untilspace( ptr ) );

    *adrs = ad;
    return attr;
}


private INLINE void	work( address adrs , int attr , int pass , int line )
{
    switch ( pass ) {
    case 0 :
	if( !regist_label( adrs , attr ) )
	    err( 0 , "??? %ds address %x\n" , line , adrs );
	break;
    case 1 :
	if( isPROLABEL( attr ) ) {
	    if( Debug & BDEBUG )
		printf( "work:prog %x\n" , (unsigned int)adrs );
	    if( !analyze( adrs , ANALYZE_IGNOREFAULT ) )
		err( 0 , "\nAddress %x(labelfile Line %d)̓vOƌȂ܂" ,
		     adrs , line );
	} else {
	    switch( attr & 0xff ) {
	    case RELTABLE :
		relative_table( adrs );
		break;
	    case RELLONGTABLE :
		relative_longtable( adrs );
		break;
	    case ZTABLE :
		z_table( adrs );
		break;
	    default:
		if( !regist_label( adrs , attr ) )
		    err( 0 , "\n??? labelfile %ds address %x" , line , adrs );
		break;
	    }
	}
    }
}


/*

  xt@Cǂݍ

*/
extern void	read_labelfile( char *filename )
{
    FILE	*fp;
    int		pass;

    if( ( fp = fopen( filename , "rt" ) ) == NULL ) {
	err( 1 , "\n%s I[vł܂łB\n" , filename );
	return;
    }

    for( pass = 0 ; pass < 2 ; pass++ ) {
	int   line;

	if( Debug & BDEBUG )
	    printf( "pass %d\n" , pass );
	for( line = 1 ; ; line++ ) {
	    char  linebuf[1024];

	    if( fgets( linebuf , sizeof(linebuf) , fp ) == NULL )
		break;
	    linebuf[ strlen( linebuf ) - 1 ] = '\0';
	    if( isxdigit( linebuf[0] ) ) {
		address	adrs;
		int	attr;
		char	*symptr;

		attr = getline( linebuf , line , pass , &adrs , &symptr );
		if( attr != -1 )
		    work( adrs , attr , pass , line );
		if( pass == 0 ) {
#if 0
		    del_symbol( adrs );
#endif
		    while( *symptr && *symptr != '*' ) {
			char *symend = untilspace( symptr );
			char *nextsym = skipspace( symend );
			char *label;
			*symend = '\0';
			label = Malloc( strlen( symptr ) + 1 );
			strcpy( label , symptr );
			add_symbol( adrs , 0 , label );
			symptr = nextsym;
		    }
		}
	    }
	}
	if( pass == 0 )
	    rewind( fp );
    }
    fclose( fp );
}


/* EOF */
