/* $Id: option.c,v 1.1 1996/11/07 08:03:54 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	Option analyze , etc
 *	Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *	All rights reserved.
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

#include <stdio.h>
#include <string.h>	/* memcmp */
#include <stdlib.h>	/* atoi */
#include <ctype.h>	/* isxdigit */
#include <limits.h>	/* PATH_MAX */

#ifdef unix
    #include <unistd.h>
#endif

#include "estruct.h"
#include "global.h"
#include "disasm.h"	/* Disasm_* */
#include "generate.h"	/* Data_width , String_width */
#include "etc.h"
#include "hex.h"	/* Hex */
#include "option.h"


private void	option_switch( int , char** );


boolean option_a , option_c , option_d , option_e , option_g , option_h ,
	option_i , option_k , option_l , option_p , option_q , option_r ,
	option_t , option_v , option_x , option_y , option_z , option_B ,
	option_D , option_E , option_I , option_M , option_N , /* option_Q , */
	option_S , option_T , option_U , option_Z;

boolean option_overwrite;


/* main.c */
extern short	sp_a7_flag;
extern short	MPU_type;
extern short	MMU_type;
extern short	FPCP_type;
extern short	FPCP_ID[16];	/* bit0͖ bit1,2,30`7̈Ӗ */
extern short	Emulate_mode;	/* bit0=1:fpsp bit1=1:isp emulation߂F */
extern int	String_length_min;
extern char	Labelfilename_in[PATH_MAX+1];
extern char	Labelfilename_out[PATH_MAX+1];
extern char	Tablefilename[PATH_MAX+1];
extern char	Filename[2][PATH_MAX+1];
extern char	CommentChar;
extern address	Base , Exec;
extern int	Verbose;
extern int	UndefRegLevel;
extern int	Quiet_mode;

extern int	SymbolColonNum;

extern int	Symbolbufsize;		/* symbol.c */
extern int	Output_AddressCommentLine;  /* output.c */
extern int	Output_SplitByte;


#ifndef unix
int	getopt( int , char** , char* );
extern int  optind;
extern char *optarg;
#endif


private char *stdiofile( char *filename )
{
    return (strcmp("-",filename) == 0) ? "aout" : filename;
}


/*

  IvV͂

*/
extern void analyze_args( int argc , char *argv[] )
{
    int     file = 0, fileind;
    char    filename[PATH_MAX+1] , ext[PATH_MAX+1];
    char    *envptr;
    int     c;

    const char optionlist[] =
	"a::b:cde::fg::hijklm:n:o:pq::rs:u::vw:xyz:ABC::DEFIK:L:MNP:QR:S::T::UV:XZ::#:-:";

    if( argc == 1 )
	usage( 1 );

    /* set default value */
    Symbolbufsize = 1024;	/* xobt@̐ */
    Data_width = 8;		/* f[^̈̉oCg */
    String_width = 60;		/* ̈̉oCg */
    String_length_min = 3;	/* ̍ŏ */
    Verbose = 1;		/* x */
    Quiet_mode = 0;		/* Îx */

    Labelfilename_in[0] = Labelfilename_out[0] = '\0';
    Tablefilename[0] = '\0';

    option_a = option_c = option_d = option_e = option_g = option_h =
    option_i = option_k = option_l = option_p = option_q = option_r =
    option_t = option_v = option_x = option_y = option_z = option_B =
    option_D = option_E = option_I = option_M = option_N = /* option_Q = */
    option_S = option_T = option_U = option_Z = FALSE;

    option_overwrite = FALSE;


    /* process environment variable `dis_opt' */
    if( /* ( option_Q == FALSE ) && */ ( envptr = getenv( DIS_ENVNAME ) ) ) {
#ifdef USE_STRBPL
	char	*ptr;
	char	env[256];
	char	**args;
	int	opts;
	int	count = 1;

	args = alloca( 64 * sizeof( char* ) );
	strncpy( env , envptr , 256 );
	for( ptr = env ; *ptr ; ptr++ )
	    if( *ptr == ' ' ) {
		count++;
		*ptr = '\0';
	    }
	*++ptr = '\0';
	opts = strbpl( args + 1, count + 1 , env ) + 1;
	args[0] = argv[0];  /* fake getopt */

	/* optind = -1; */
	while( ( c = getopt( opts , args , optionlist ) ) != EOF )
	    option_switch( c , args );
#else
	int count , cnt;
	char *envs , *envp;	/* envs=Œ, envp=Ɨp */
	char **args , **argp;	/* args=Œ, argp=Ɨp */

	/* Xy[Xŕ */
	while( *envptr == ' ' ) envptr++;
	envp = envs = Malloc( strlen( envptr ) + 1 );
	for( count = 1 ; *envptr ; count++ ) {
	    while( *envptr && (*envptr != ' ') )
		*envp++ = *envptr++;
	    *envp++ = '\0';
	    while( *envptr == ' ' ) envptr++;
	}

	/* eւ̃|C^z */
	argp = args = Malloc( ( count + 1 ) * sizeof( char * ) );
	envp = envs;
	*argp++ = argv[0];		/* my name */
	for( cnt = count ; --cnt ; ) {
	    *argp++ = envp;
	    while( *envp++ ) ;
	}
	*argp = NULL;

	/* IvV */
	/* optind = -1; */
	while( ( c = getopt( count , args , optionlist ) ) != EOF )
	    option_switch( c , args );

	/* Yꂸɉ */
	Mfree( args );
	Mfree( envs );
#endif
    }

    /* process commandline variable */
    {
	optind = -1;
	while( ( c = getopt( argc , argv , optionlist ) ) != EOF )
	    option_switch( c , argv );
	fileind = optind;
    }


    while( fileind < argc ) {
	if( file < 2 )
	    strcpy( Filename[ file++ ] , argv[fileind++] );
	else
	    err( 1 , "t@C܂\n" );
    }
    if( file == 0 ) usage( 1 );
    if( file == 1 ) strcpy( Filename[ 1 ], "-" );


    if( Emulate_mode & 1 ) {
	short tmp = FPCP_type;
	if( tmp & F040 ) tmp |= F4SP;
	if( tmp & F060 ) tmp |= F6SP;
	FPCP_type = tmp;
    }

    if( (MMU_type == MMU851) && (MPU_type != 20) )
	err( 1 , "-m68851  -m68020 Ƃpł܂\n" );

    if( MPU_type >= 40 ){
	int i;
	for( i=2; i<=7; i++ )
	    if( FPCP_ID[i*2] )
		err( 1 , "-m68040/68060 w莞 -m6888x  ID  1 Œł\n" );
    }


    /* if invoked with -T , labelfile must be read */
    if( option_T ) option_g = TRUE;

    {
	char *p;

	strcpy( filename, Filename[1] );
	p = rindex( filename, '.' );
	if( p ){
	    *p = '\0';
	}

	p = rindex( Filename[1], '.' );
	if( p )
	    strcpy( ext, p+1 );
	else
	    ext[0] = '\0';
    }


    if( option_e && Labelfilename_out[0] == '\0' ) {
	strcat( Labelfilename_out , stdiofile(filename) );
	strcat( Labelfilename_out , ".lab" );
    }
    if( option_g && Labelfilename_in[0] == '\0' ) {
	strcat( Labelfilename_in , stdiofile(filename) );
	strcat( Labelfilename_in , ".lab" );
    }
    if( option_T && Tablefilename[0] == '\0' ) {
	strcpy( Tablefilename , stdiofile(filename) );
	strcat( Tablefilename , ".tab" );
    }
#if 0
/* TwentyOneŃ}`sIhȊ̂ŁÃ`FbN͏ȂƂɂ܂ ^^ (ryo) */
    if( option_S ) {
	if( ext[0] != '\0' || strchr( Filename[1] , '.' ) != NULL )
	    err( 1 , "-S option ɂ͏o̓t@CɊgq͕spł\n" );
    }
#endif
}


private void	option_switch( int opt , char **argv )
{
    int optnum = 0;
    if( optarg ) optnum = atoi( optarg );

    switch( opt ) {
    case 'a':
	option_a = TRUE;
	Output_AddressCommentLine = ( optarg ? optnum : 5 );
	break;
    case 'b':
	if( optarg == NULL ) exit(1);
	Generate_SizeMode = optnum;
	break;
    case 'c':
	option_c = TRUE;
	break;
    case 'd':
	option_d = TRUE;
	break;
    case 'e':
	option_e = TRUE;
	if( optarg ) strcpy( Labelfilename_out , optarg );
	break;
    case 'f':
	Disasm_Exact = FALSE;
	break;
    case 'g':
	option_g = TRUE;
	if( optarg ) strcpy( Labelfilename_in , optarg );
	break;
    case 'h':
	option_h = TRUE;
	break;
    case 'i':
	option_i = TRUE;
	break;
    case 'j':
	Disasm_AddressErrorUndefined = FALSE;
	break;
    case 'k':
	option_k = TRUE;
	break;
    case 'l':
	option_l = TRUE;
	break;
    case 'm':
	{
	    char *f,*i;
	    int id;
	    if( ( f = optarg ) == NULL ) exit(1);

	    if( strcmp( f , "68000" ) == 0 ){	MPU_type = 0; break; }
	    if( strcmp( f , "68010" ) == 0 ){	MPU_type = 10; break; }
	    if( strcmp( f , "68020" ) == 0 ){	MPU_type = 20; break; }
	    if( strcmp( f , "68030" ) == 0 ){	MPU_type = 30;
						MMU_type = MMU030;
						break; }
	    if( strcmp( f , "68040" ) == 0 ){	MPU_type = 40;
						MMU_type = MMU040;
						FPCP_type &= !(F060|F6SP);
						FPCP_type |= F040;
						FPCP_ID[ 1*2 ] = 1;
						break; }
	    if( strcmp( f , "68060" ) == 0 ){	MPU_type = 60;
						MMU_type = MMU060;
						FPCP_type &= !(F040|F4SP);
						FPCP_type |= F060;
						FPCP_ID[ 1*2 ] = 1;
						break; }
	    if( strcmp( f , "68851" ) == 0 ){	MMU_type = MMU851;
						break; }

	    i = index( f, ',' );
	    if( i != NULL ){
		*i++ = '\0';
		id = atoi(i);
		if( 1 <= id && id <= 7 )
		    FPCP_ID[ id*2 ] = 1;
		else
		    goto fpcp_error;
	    }else
		FPCP_ID[ 1*2 ] = 1;

	    if( strcmp( f , "68881" ) == 0 ){	FPCP_type |= F881; break; }
	    if( strcmp( f , "68882" ) == 0 ){	FPCP_type |= F882; break; }

fpcp_error:
	    err( 1 , "w MPU, FPCP, FPCP-ID ̓T|[gĂ܂( -m option )\n" );
	}
	break;
    case 'n':
	if( optarg == NULL ) exit(1);
	String_length_min = optnum;
	break;
    case 'o':
	if( optarg == NULL ) exit(1);
	String_width = optnum;
	if( String_width < 1 || 80 < String_width )
	    err( 1 , "lȔ͈͂ł( -o option )\n" );
	break;
    case 'p':
	option_p = TRUE;
	break;
    case 'q':
	option_q = TRUE;
	if( optarg ) Quiet_mode = optnum;
	if( Quiet_mode < 0 || Quiet_mode > 1 )
	    err( 1 , "lȔ͈͂ł( -q option )\n" );
	break;
    case 'r':
	option_r = TRUE;
	break;
    case 's':
	if( optarg == NULL ) exit(1);
	Symbolbufsize = optnum + 1;
	break;
/*
    case 't':
	option_t = TRUE;
	break;
*/
    case 'u':
	Disasm_UnusedTrapUndefined = FALSE;
	if( optarg && optnum == 1 )
	    Disasm_SX_Window = TRUE;
	break;
    case 'v':
	option_v = TRUE;
	break;
    case 'w':
	if( optarg == NULL ) exit(1);
	Data_width = optnum;
	if( Data_width < 1 || 32 < Data_width )
	    err( 1 , "lȔ͈͂ł( -w option )\n" );
	break;
    case 'x':
	option_x = TRUE;
	break;
    case 'y':
	option_y = TRUE;
	break;
    case 'z':
	if( optarg == NULL ) exit(1);
	option_z = TRUE;
	Absolute = ABSOLUTE_ZOPT;
	Base = (address)1;
	Exec = (address)0;

	if( optarg ) {
	    char *p;
	    p = strchr( optarg , ',' );
	    if( p != NULL ){
		*p++ = '\0';
		Base = (address)atox( optarg );
		Exec = (address)atox( p );
	    }
	}
	if( Base > Exec ){
	    err( 1 , "-z option ُ̈\n" );
	}
	break;
    case 'A':
	Disasm_MnemonicAbbreviation = TRUE;
	break;
    case 'B':
	option_B = TRUE;
	break;
    case 'C':
	SymbolColonNum = optnum;
	if( SymbolColonNum < 0 || 3 < SymbolColonNum )
	    err( 1 , "lȔ͈͂ł( -C option )\n" );
	break;
    case 'D':
	option_D = TRUE;
	break;
    case 'E':
	option_E = TRUE;
	break;
    case 'F':
	Disasm_Dbra = FALSE;
	break;
    case 'I':
	option_I = TRUE;
	break;
    case 'K':
	if( optarg == NULL ) exit(1);
	CommentChar = *optarg;
	break;
    case 'L':
	if( optarg == NULL ) exit(1);
	if( isdigit( *optarg ) )
	    err( 1 , "x̐擪ɐ͎g܂( -L )\n" );
	Label_first_char = *optarg;
	break;
    case 'M':
	option_M = TRUE;
	break;
    case 'N':
	option_N = TRUE;
	break;
    case 'P':
	if( optarg == NULL ) exit(1);
	Emulate_mode = optnum;
	if( 3 < Emulate_mode )
	    err( 1 , "lȔ͈͂ł( -P option )\n" );
	break;
    case 'Q':
    /*  option_Q = TRUE;  */
	break;
    case 'R':
	if( optarg == NULL ) exit(1);
	UndefRegLevel = optnum;
	if( UndefRegLevel < 0 || 15 < UndefRegLevel )
	    err( 1 , "lȔ͈͂ł( -R option )\n" );
	break;
    case 'S':
	option_S = TRUE;
	Output_SplitByte = ( optarg ? optnum : 64 ) * 1024;
	break;
    case 'T':
	option_T = TRUE;
	if( optarg ) strcpy( Tablefilename , optarg );
	break;
    case 'U':
	Disasm_MnemonicUpper = TRUE;
	option_U = TRUE;
	break;
    case 'V':
	if( optarg == NULL ) exit(1);
	Verbose = optnum;
	if( Verbose < 0 || 2 < Verbose )
	    err( 1 , "lȔ͈͂ł( -V option )\n" );
	break;
    case 'X':
	strupr( Hex );
	break;
    case 'Z':
	option_Z = TRUE;
	Zerosupress_mode = optnum;
	if( Zerosupress_mode < 0 || 1 < Zerosupress_mode )
	    err( 1 , "lȔ͈͂ł( -Z option )\n" );
	break;
    case '#':
	if( optarg == NULL ) exit(1);
	Debug = optnum;
	break;
#if 0
    case '7':
	sp_a7_flag = TRUE;
	break;
#endif
    case '-':
	if( optarg ) {

#define isLONGOPT( str ) (strcmp( optarg , str ) == 0)

	         if( isLONGOPT(    "fpsp" ) )	Emulate_mode |=  1;
	    else if( isLONGOPT( "no-fpsp" ) )	Emulate_mode &= ~1;
	    else if( isLONGOPT(    "isp" ) )	Emulate_mode |=  2;
	    else if( isLONGOPT( "no-isp" ) )	Emulate_mode &= ~2;
	    else if( isLONGOPT( "no-fpu" ) )	FPCP_type = 0;
	    else if( isLONGOPT( "no-mmu" ) )	MMU_type = 0;

	    else if( isLONGOPT( "overwrite" ) )	option_overwrite = TRUE;
	    else if( isLONGOPT( "sp" ) )	sp_a7_flag = TRUE;
	    else if( isLONGOPT( "a7" ) )	sp_a7_flag = FALSE;
	    else if( isLONGOPT( "help" ) )	usage( 0 );
	    else if( isLONGOPT( "version" ) ) { printf( "dis version %s\n" , Version );
						exit( 0 ); }
	    else
		err( 1 , "%s: unrecognized option '--%s'\n" , argv[0] , optarg );
	}
	break;
/*  case '?':  */
    default:
	exit( 1 );
	break;
    }
    return;
}



extern void usage( int exitcode )
{
    extern print_title();	/* main.c */

    static char *message =
	"usage: dis [option] st@C [o̓t@C]\n"
	"option:\n"

	/* IvV */
	"	-a[num]		numsƂɃAhXRgœ(num ȗ5s)\n"
	"	-b num		Ε򖽗߂̃TCYw (0:ftHg,1:ɏȗ,2:ɕt)\n"
	"	-c		x`FbNsȂ\n"
	"	-d		foCXhCo̎Ɏw\n"
	"	-e[file]	xt@C̏o\n"
	"	-f		oCg얽߂̕soCg̃`FbN($00 or $ff ?)Ȃ\n"
	"	-g[file]	xt@Cǂݍ\n"
	"	-h		f[^̈撆$4e75̎̃AhXɒڂ\n"
	"	-i		Ŗ`߂Ăf[^̈ƌȂȂ\n"
	"	-j		AhXG[Nł낤߂𖢒`߂ƌȂȂ\n"
	"	-k		߂̒wx͂Ȃ̂ƌȂ\n"
	"	-l		vÖ悪ȂȂ܂ŉx{ƂȂ\n"
	"	-m 680x0	tAZuΏۂMPUw(x=0`4, l-m68000)\n"
	"	-m 68851	68851߂Lɂ(-m68020 w莞̂ݗL)\n"
	"	-m 6888x[,ID]	LFPCPƂIDw(68881 or 882, ID=[1],2,..,7)\n"
	"	-n num		ƂĔ肷ŏ̒. 0Ȃ画肵Ȃ(l3)\n"
	"	-o num		̈̉oCg(1num80, l70)\n"
	"	-p		f[^̈撆̃vÖ𔻕ʂȂ\n"
	"	-q[num]		bZ[Wo͂Ȃ([0]:ʏ 1:e[uɊւo͂Ȃ)\n"
	"	-r		16ĩRgt\n"
	"	-s num		V{obt@̐w(l1024)\n"
/*	"	-t		AhXe[u̎ʂsȂ\n" */
	"	-u[num]		gpA,F line trap𖢒`߂ƌȂȂ(num=1 SX-WindowΉ)\n"
	"	-v		PȂtAZuXg̏o\n"
	"	-w num		f[^̈̉oCg(1num32, l8)\n"
	"	-x		ۂ̃IyR[h16ĩRgŕt\n"
	"	-y		SẴf[^̈vÖłȂm߂邱ƂȂ\n"
	"	-z base,exec	st@CbasẽoCit@CƂ݂ȂAexec͂\n"

	/* 啶IvV */
	"\n"
	"	-A		cmpi, movea  cmp, move ɂ\n"
	"	-B		bra ̌łs\n"
	"	-C[num]		x̌̃R(0:tȂ,1:ʏ,[2]:O`ɂ2,3:SĂ2)\n"
	"	-D		f[^ZNVɂvOF߂\n"
	"	-E		oCg얽߂̕soCg̏`FbNȂ\n"
	"	-F		dbra, fdbra  dbf, fdbf Ƃďo͂\n"


	"	-I		߂̒x̃AhX\\n"

	"	-K char		char RgLN^Ƃėp\n"
	"	-L char		char x̐擪Ƃėp\n"
	"	-M		cmpi, move, addi.b, subi.b #imm  pack, unpk ɃRg\n"
	"	-N		TCYftHgȂtȂ\n"

	"	-P num		\tgEFAG~[V߂Lɂ(rbgw, l3)\n"
	"		+1	_߂Lɂ\n"
	"		+2	߂Lɂ\n"
   /*	"	-Q		ϐ dis_opt QƂȂ\n"   */
	"	-R num		gptB[h̃`FbNڂ̎w(rbgw, l15)\n"
	"		+1	mulu.l, muls.l, ftst.x ɂ関gpWX^tB[h̃`FbN\n"
	"		+2	gAhbVOł̃TvXꂽWX^tB[h̃`FbN\n"
	"		+4	TvXꂽCfbNXWX^ɑ΂XP[Õ`FbN\n"
	"		+8	TvXꂽCfbNXWX^ɑ΂TCYw(.l)̃`FbN\n"
	"	-S[num]		o̓t@C num Kbyte Ƃɕ(num ȗ 64Kbyte)\n"
	"	-T[file]	e[uLqt@Cǂݍ\n"
	"	-U		j[jbN啶ŏo͂\n"
	"	-V num		obNgbŇ̕\(0:Ȃ,[1]:vÖ,2:SĂ̗̈)\n"

	"	-X		16i啶ŏo͂\n"

	"	-Z[num]		16i[TvX([0]:ʏ 1:ȗ\'$'ȗ)\n"

	/* PꖼIvV */
	"\n"
	"	--(no-)fpsp	_߂L()ɂ\n"
	"	--(no-)isp	߂L()ɂ\n" 
	"	--no-fpu	FPU߂𖳌ɂ(-m68040`68060̌Ɏw)\n" 
	"	--no-mmu	MMU߂𖳌ɂ(-m68030`68060̌Ɏw)\n" 
	"	--sp		a7WX^'sp'ƕ\L\n"
	"	--overwrite	t@C𖳏ŏ㏑\n"
	"	--version	o[W\\n"
	"	--help		gp@\\n"

#if 0	/* BIvV */
	"\n"
	"	-#		fobO[h\n"
#endif
	; /* end of message */

    print_title();
    eprintf( message );
    exit( exitcode );
}

/* EOF */
