/* $Id: output.c,v 1.1 1996/11/07 08:03:56 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	o̓[`
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

#include	<stdio.h>
#include	<stdarg.h>
#include	<string.h>
#if !defined( STREAM ) && !defined( MYU_HEADERS )
    #include	<fcntl.h>
    #ifndef unix
    #include	<stat.h>
    #include	<io.h>
    #endif
#endif
#ifdef unix
#include	<unistd.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<sys/file.h>
#endif
#include    "estruct.h"
#include    "global.h"
#include    "etc.h"		/* err */
#include    "output.h"
#include    "disasm.h"
#include    "generate.h"	/* Atab */
#include    "hex.h"		/* strend */


USEOPTION   option_a , option_S;
extern	char	CommentChar;


/* private ֐vg^Cv */
#ifndef STREAM
private void	output_through_buffer( char* );
private void	flush_buffer( void );
#endif


int	Output_AddressCommentLine;
int	Output_SplitByte;

#ifdef STREAM
static FILE *Output_fp;
#else
static int  Output_handle;
static char *OutputLargeBuffer = NULL;
static char *OutputLargeBufferPtr;
#endif
static char OutputBuffer[256];
static char *OutputBufferEnd = OutputBuffer;
static char FilenameBody[PATH_MAX];
static boolean	SplitMode;

#define OUTPUT_BUFFER_SIZE  (64*1024)


/*

  

*/
extern void init_output( void )
{
#ifndef STREAM
    if( ( OutputLargeBuffer = Malloc( OUTPUT_BUFFER_SIZE ) ) == NULL )
	err( 1 , "o̓obt@pmۏo܂\n" );
    OutputLargeBufferPtr = OutputLargeBuffer;
#endif
}


/*

  o̓t@CI[v

*/
extern void output_file_open( char *filename , int file_block_num )
{
    char    tempfilename[PATH_MAX];

    strcpy( tempfilename , filename );

    if( !strcmp("-",filename) ) {
#ifdef STREAM
	Output_fp = stdout;
#else
	Output_handle = STDOUT;
#endif
    } else {
	if( option_S ) {
	    switch( file_block_num ) {
		case 0:
		    strcpy( FilenameBody , filename );
		    strcat( tempfilename , ".000" );
		    SplitMode = TRUE;
		    break;
		case -1:
		    strcat( tempfilename , ".dat" );
		    SplitMode = FALSE;
		    break;
		case -2:
		    strcat( tempfilename , ".bss" );
		    SplitMode = FALSE;
		    break;
		default:
		    sprintf( strend( tempfilename ) , ".%03x" , file_block_num );
	    }
	}

#ifdef	STREAM
	if( ( Output_fp = fopen( tempfilename , "w" ) ) == NULL )
	    err( 1 , "%s I[vo܂(temp)\n" , tempfilename );
#else
#ifdef	OSK
	if( ( Output_handle = creat( tempfilename , S_IREAD | S_IWRITE ) ) < 0 )
	    err( 1 , "%s I[vo܂\n" , tempfilename );
#else
	if( ( Output_handle = open( tempfilename ,
	  O_CREAT | O_WRONLY | O_TRUNC | O_BINARY , S_IRUSR|S_IWUSR ) ) < 0 )
	    err( 1 , "%s I[vo܂(temp)\n" , tempfilename );
#endif	/* OSK */
#endif

    }
}


extern void output_file_close( void )
{
#ifdef STREAM
    fclose( Output_fp );
#else
    flush_buffer();
    close( Output_handle );
#endif
}


/*

  ݃G[

*/
private void	diskfull( void )
{
#ifdef STREAM
    fclose( Output_fp );
#else
    close( Output_handle );
#endif
    err( 1 , "\nfBXNtł\n" );
}


/*

  t@C֏o

*/
extern void outputf( char *fmt , ... )
{
#ifndef STREAM
    char    tmp[256];
#endif
    va_list ap;
    va_start( ap , fmt );

#ifdef STREAM
    vfprintf( Output_fp , fmt , ap );
    if( ferror( Output_fp ) )
	diskfull();
#else
    vsprintf( tmp , fmt , ap );
    output_through_buffer( tmp );
#endif
    va_end( ap );
}


extern void outputa( char *str )
{
    strcpy( OutputBufferEnd , str );
    OutputBufferEnd = strend( OutputBuffer );
}


extern void outputca( int ch )
{
    *OutputBufferEnd++ = ch;
    *OutputBufferEnd   = '\0';
}


extern void outputfa( char *fmt , ... )
{
    va_list ap;
    va_start( ap , fmt );

    vsprintf( OutputBufferEnd , fmt , ap );
    OutputBufferEnd = strend( OutputBuffer );

    va_end( ap );
}


#if 0
extern void outputax( ULONG num , int width )
{
    OutputBufferEnd = itox( OutputBufferEnd , num , width );
}
#endif

extern void outputaxd( ULONG num , int width )
{
    OutputBufferEnd = itoxd( OutputBufferEnd , num , width );
}


extern void outputax2_without_0supress( ULONG num )
{
    *OutputBufferEnd++ = '$';
    OutputBufferEnd = itox2_without_0supress( OutputBufferEnd , num );
}

extern void outputax4_without_0supress( ULONG num )
{
    *OutputBufferEnd++ = '$';
    OutputBufferEnd = itox4_without_0supress( OutputBufferEnd , num );
}

extern void outputax8_without_0supress( ULONG num )
{
    *OutputBufferEnd++ = '$';
    OutputBufferEnd = itox8_without_0supress( OutputBufferEnd , num );
}


extern void newline( address lineadrs )
{
    static int linecount = 1;
    static int file_block_num = 0;
    int i , len;
    char *ptr;

    if( option_S && SplitMode ) {
	if( Output_SplitByte <=
	  (long)lineadrs - (long)BeginTEXT - Output_SplitByte * file_block_num &&
#ifdef STREAM
	  OutputBuffer[0] == '\n'
#else
	  OutputBuffer[0] == '\n'
#endif
	) {
	    file_block_num++;
	    output_file_close();
	    output_file_open( FilenameBody , file_block_num );
	}
    }

    if( option_a ) {
	if( linecount >= Output_AddressCommentLine ) {
	    for( ptr = OutputBuffer , len = 0 ; *ptr ; ptr++ ) {
		switch( *ptr ) {
		case '\t':
		    len += 8 - len % 8;
		    break;
		case '\n':
		    len = 0;
		    break;
		default:
		    len++;
		    break;
		}
	    }

	    for( i = Atab - len / 8 - 1 ; i > 0 ; i-- )
		*OutputBufferEnd++ = '\t';
	    *OutputBufferEnd++ = '\t';
	    *OutputBufferEnd++ = CommentChar;

	    OutputBufferEnd = itox6( OutputBufferEnd, (ULONG)lineadrs );
	    linecount = 1;
	} else {
	    linecount++;
	}
    }

#ifdef	OSK
    *OutputBufferEnd++ = '\n';
#else
#ifdef STREAM
    *OutputBufferEnd++ = '\n';
#else
    *OutputBufferEnd++ = '\n';
#endif
#endif	/* OSK */
    *OutputBufferEnd   = '\0';

#ifdef STREAM
    fputs( OutputBuffer , Output_fp );
    if( ferror( Output_fp ) )
	diskfull();
#else
    output_through_buffer( OutputBuffer );
#endif
    OutputBufferEnd = OutputBuffer;
}


#ifndef STREAM
private void	output_through_buffer( char *str )
{
    strcpy( OutputLargeBufferPtr , str );
    OutputLargeBufferPtr = strend( OutputLargeBufferPtr );

    if( OutputLargeBufferPtr - OutputLargeBuffer > OUTPUT_BUFFER_SIZE - 1024 )
	flush_buffer();
}


private void	flush_buffer( void )
{
    long length = OutputLargeBufferPtr - OutputLargeBuffer;

    if( write( Output_handle , OutputLargeBuffer , length ) < length )
	diskfull();

    OutputLargeBufferPtr = OutputLargeBuffer;
}
#endif /* STREAM */




#if 0
/* following functions is no longer used. */

extern void output( char *str )
{
    fputs( str , Output_fp );
    if( ferror( Output_fp ) )
	diskfull();
}
extern void outputc( int ch )
{
    fputc( ch , Output_fp );
}

#endif /* 0 */


/* EOF */
